#include "/home/pulungan/tools/mobius/MobiusProject/rdt/Atomic/rdt1_0/rdt1_0EXT.h"

// per default include all parts of the file
#define MODEST_INCLUDE_GUARDS
#define MODEST_INCLUDE_PARAMETER_PASSERS
#define MODEST_INCLUDE_ASSIGNMENTS
#define MODEST_INCLUDE_MODEL

#ifdef MODEST_TEST_GUARDS
# define MODEST_INCLUDE_GUARDS
# undef MODEST_INCLUDE_PARAMETER_PASSERS
# undef MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif
#ifdef MODEST_TEST_PARAMETER_PASSERS
# undef MODEST_INCLUDE_GUARDS
# define MODEST_INCLUDE_PARAMETER_PASSERS
# undef MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif
#ifdef MODEST_TEST_ASSIGNMENTS
# undef MODEST_INCLUDE_GUARDS
# undef MODEST_INCLUDE_PARAMETER_PASSERS
# define MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif

#ifdef MODEST_INCLUDE_GUARDS

#endif // MODEST_INCLUDE_GUARDS

#ifdef MODEST_INCLUDE_PARAMETER_PASSERS

#endif // MODEST_INCLUDE_PARAMETER_PASSERS

#ifdef MODEST_INCLUDE_ASSIGNMENTS
	class Assign_3_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_loss->setValue( 1 );
		}
		Assign_3_0( ModestVariable<int>* g__loss )
		: ModestAssignmentFunctor()
		, g_loss(g__loss)
		{
		}
		ModestVariable<int>* g_loss;
	};
	class Assign_6_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_loss->setValue( g_loss->getValue(/*wid*/) - 1 );
		}
		Assign_6_0( ModestVariable<int>* g__loss )
		: ModestAssignmentFunctor()
		, g_loss(g__loss)
		{
		}
		ModestVariable<int>* g_loss;
	};

#endif // MODEST_INCLUDE_ASSIGNMENTS

#ifdef MODEST_INCLUDE_MODEL

static const rdt1_0EXT::mask_type bitmasks_local = {
	  { 0x49 } // Root Process Enable Mask
	, { 0xff }
	, { 0x1 }
	, { 0x7 }
	, { 0x2 }
	, { 0x4 }
	, { 0 }
	, { 0x8 }
	, { 0x38 }
	, { 0x10 }
	, { 0x20 }
	, { 0x40 }
	, { 0xc0 }
	, { 0x80 }
};

rdt1_0EXT::mask_type* rdt1_0EXT::bitmasks = &bitmasks_local;

void rdt1_0EXT::CurrentState( void* memory )
{
	StateStruct* ss = static_cast<StateStruct*>(memory);

	std::memcpy( ss->enabling_bits, enabling_bits, 1*sizeof(bitvector_type));
	ss->loss = loss->getValue();
}

void rdt1_0EXT::SetState( void* memory )
{
	StateStruct* ss = static_cast<StateStruct*>(memory);

	std::memcpy( enabling_bits, ss->enabling_bits, 1*sizeof(bitvector_type));
	loss->setValue(ss->loss);
}

void rdt1_0EXT::printState( std::ostream *strm )
{
	(*strm)
		<< "bit0 = " << ((enabling_bits[0] & 1UL) != 0) << std::endl
		<< "bit1 = " << ((enabling_bits[0] & 2UL) != 0) << std::endl
		<< "bit2 = " << ((enabling_bits[0] & 4UL) != 0) << std::endl
		<< "bit3 = " << ((enabling_bits[0] & 8UL) != 0) << std::endl
		<< "bit4 = " << ((enabling_bits[0] & 16UL) != 0) << std::endl
		<< "bit5 = " << ((enabling_bits[0] & 32UL) != 0) << std::endl
		<< "bit6 = " << ((enabling_bits[0] & 64UL) != 0) << std::endl
		<< "bit7 = " << ((enabling_bits[0] & 128UL) != 0) << std::endl
		<< "loss = " << loss->getValue() << std::endl
		;
}
rdt1_0EXT::~rdt1_0EXT()
{
	if( term_tree ) delete term_tree;
	if( con ) delete [] con;
}

rdt1_0EXT::rdt1_0EXT()
: ModestModel()
, con(0)
, term_tree(0)
, loss( new ModestVariable<int>( "loss" ) )
, deliver_data_13( new ModestAction( "deliver_data_13", 0, 0, 0x20, this ) )
, extract_12( new ModestAction( "extract_12", 1, 0, 0x10, this ) )
, make_pkt_5( new ModestAction( "make_pkt_5", 2, 0, 0x2, this ) )
, rdt_rcvSync0( new ModestSyncAction( "rdt_rcvSync0", 3, this ) )
, rdt_rcv_10( new ModestAction( "rdt_rcv_10", 3, 0, 0x8, this ) )
, rdt_rcv_17( new ModestAction( "rdt_rcv_17", 3, 0, 0x80, this ) )
, rdt_send_4( new ModestAction( "rdt_send_4", 4, 0, 0x1, this ) )
, udt_sendSync1( new ModestSyncAction( "udt_sendSync1", 5, this ) )
, udt_send_6( new ModestAction( "udt_send_6", 5, 0, 0x4, this ) )
, udt_send_16( new ModestAction( "udt_send_16", 5, 0, 0x40, this ) )
, bit0( "bit0", 0, enabling_bits, 1 )
, bit1( "bit1", 1, enabling_bits, 1 )
, bit2( "bit2", 2, enabling_bits, 1 )
, bit3( "bit3", 3, enabling_bits, 1 )
, bit4( "bit4", 4, enabling_bits, 1 )
, bit5( "bit5", 5, enabling_bits, 1 )
, bit6( "bit6", 6, enabling_bits, 1 )
, bit7( "bit7", 7, enabling_bits, 1 )
{
	setCollector( new CollectVisitor( 1 ) );
	TTDReader read_termtree("/home/pulungan/tools/mobius/MobiusProject/rdt/Atomic/rdt1_0/rdt1_0.ttd", this, term_tree, con );

	con[6]->setAssigner( 0, new Assign_3_0(  loss ) );
	con[10]->setAssigner( 0, new Assign_6_0(  loss ) );

	// Link guards/assignments to constructs

	// Link the actions to the termtree
	deliver_data_13->setConstruct( con[13] );
	extract_12->setConstruct( con[12] );
	make_pkt_5->setConstruct( con[5] );
	rdt_rcv_10->setConstruct( con[10] );
	rdt_rcv_17->setConstruct( con[17] );
	rdt_send_4->setConstruct( con[4] );
	udt_send_6->setConstruct( con[6] );
	udt_send_16->setConstruct( con[16] );

	// Set up dependency information
	bit5.appendEnabledAction( deliver_data_13 );
	deliver_data_13->addEnablingSV( &bit5 );
	bit4.appendEnabledAction( extract_12 );
	extract_12->addEnablingSV( &bit4 );
	bit5.appendAffectingAction( extract_12 );
	extract_12->addAffectedSV( &bit5 );
	bit1.appendEnabledAction( make_pkt_5 );
	make_pkt_5->addEnablingSV( &bit1 );
	bit2.appendAffectingAction( make_pkt_5 );
	make_pkt_5->addAffectedSV( &bit2 );
	bit3.appendEnabledAction( rdt_rcvSync0 );
	rdt_rcvSync0->addEnablingSV( &bit3 );
	rdt_rcvSync0->addAffectedSV( loss );
	loss->appendAffectingAction( rdt_rcvSync0 );
	bit4.appendAffectingAction( rdt_rcvSync0 );
	rdt_rcvSync0->addAffectedSV( &bit4 );
	bit7.appendEnabledAction( rdt_rcvSync0 );
	rdt_rcvSync0->addEnablingSV( &bit7 );
	bit0.appendEnabledAction( rdt_send_4 );
	rdt_send_4->addEnablingSV( &bit0 );
	bit1.appendAffectingAction( rdt_send_4 );
	rdt_send_4->addAffectedSV( &bit1 );
	bit2.appendEnabledAction( udt_sendSync1 );
	udt_sendSync1->addEnablingSV( &bit2 );
	udt_sendSync1->addAffectedSV( loss );
	loss->appendAffectingAction( udt_sendSync1 );
	bit6.appendEnabledAction( udt_sendSync1 );
	udt_sendSync1->addEnablingSV( &bit6 );
	bit7.appendAffectingAction( udt_sendSync1 );
	udt_sendSync1->addAffectedSV( &bit7 );

	// Set up synchronizing actions
	rdt_rcvSync0->addAtomicAction( rdt_rcv_10 );
	rdt_rcvSync0->addAtomicAction( rdt_rcv_17 );
	udt_sendSync1->addAtomicAction( udt_send_6 );
	udt_sendSync1->addAtomicAction( udt_send_16 );

	// Init arrays for variables
	BaseStateVariableClass* ROVars[] = {
		&bit0,
		&bit1,
		&bit2,
		&bit3,
		&bit4,
		&bit5,
		&bit6,
		&bit7,
		loss,
		0
	};
	BaseStateVariableClass* SVars[] = { 
		loss,
		0
	};
	// Write Init arrays for actions
	BaseActionClass* InitialActionList[] = {
			deliver_data_13,
			extract_12,
			make_pkt_5,
		rdt_rcvSync0,
			rdt_send_4,
		udt_sendSync1,
		0
	};
	BaseGroupClass* InitialGroupList[] = {
		deliver_data_13,
		extract_12,
		make_pkt_5,
		rdt_rcvSync0,
		rdt_send_4,
		udt_sendSync1,
		0
	};

	initializeModelNow("rdt1_0",
		(sizeof(SVars) / sizeof(BaseStateVariableClass*))-1, SVars,
		(sizeof(ROVars) / sizeof(BaseStateVariableClass*))-1, ROVars,
		(sizeof(InitialActionList) / sizeof(BaseActionClass*))-1, InitialActionList,
		(sizeof(InitialGroupList) / sizeof(BaseGroupClass*))-1, InitialGroupList);

	// Set the initial state
	con[1]->kick_passers();
	const ModestConstruct::mask_type* mask = con[1]->getEnableMask();
	for(unsigned int i = 0; i < 1; i++)
		enabling_bits[i] = mask[i];
} // end constructor
#endif // MODEST_INCLUDE_MODEL
