#ifndef __rdt2_0EXT_H__
#define __rdt2_0EXT_H__

#include "Cpp/BaseClasses/Modest/bool_fun.h"
#include "Cpp/BaseClasses/Modest/ModestGuard.h"
#include "Cpp/BaseClasses/Modest/ModestConstruct.h"
#include "Cpp/BaseClasses/Modest/ModestAction.h"
#include "Cpp/BaseClasses/Modest/ModestSyncAction.h"
#include "Cpp/BaseClasses/Modest/ModestVariable.h"
#include "Cpp/BaseClasses/Modest/ModestStructVariable.h"
#include "Cpp/BaseClasses/Modest/ModestArrayVariable.h"
#include "Cpp/BaseClasses/Modest/ModestModel.h"
#include "Cpp/BaseClasses/Modest/StateBit.h"
#include "Cpp/BaseClasses/Modest/TTDReader.h"

// Type-definitions for user defined types


// Model Parameters

class rdt2_0EXT : public ModestModel {
public:
	typedef ModestModel::bitvector_type bitvector_type;

	typedef const ModestModel::bitvector_type mask_type[45][1];

	static mask_type *bitmasks;

	virtual const bitvector_type* getBitMask( size_t idx ) const {
		return &((*bitmasks)[idx][0]);
	}

	// Structure used for state save/restore
	typedef struct {
		bitvector_type enabling_bits[1];
		int	resending;
		int	status;
	} StateStruct;

	virtual int StateSize() {
		return sizeof(StateStruct);
	}

	virtual void CurrentState( void* memory );
	virtual void SetState( void* memory );
	virtual void printState( void ) { printState(&std::cout); } ;
	virtual void printState( std::ostream *strm );

	virtual bool checkEnablingBits( unsigned int offset, bitvector_type mask ) const
	{
		return ((enabling_bits[offset] & mask) != 0);
	}

	virtual bitvector_type* getEnablingBits()
	{
		return enabling_bits;
	}

	ModestConstruct* getTermTree( void ) const {
		return term_tree;
	}


	// Constructor for the model
	rdt2_0EXT();

	// Constructor for the model
	virtual ~rdt2_0EXT();
public:
	ModestConstruct** con;		// array for construct tree
	ModestConstruct* term_tree;		// root of the construct tree


	// Attributes for variables
	ModestVariable<int>* resending;
	ModestVariable<int>* status;

	// Attributes for the actions in the model
	ModestAction* break_15;
	ModestAction* compute_checksum_5;
	ModestAction* deliver_data_29;
	ModestAction* extract_28;
	ModestAction* make_pkt_6;
	ModestSyncAction* rdt_rcv_ACKSync0;
	ModestAction* rdt_rcv_ACK_14;
	ModestAction* rdt_rcv_ACK_49;
	ModestSyncAction* rdt_rcv_NAKSync1;
	ModestAction* rdt_rcv_NAK_11;
	ModestAction* rdt_rcv_NAK_46;
	ModestSyncAction* rdt_rcv_packetSync2;
	ModestAction* rdt_rcv_packet_19;
	ModestAction* rdt_rcv_packet_39;
	ModestSyncAction* rdt_rcv_packetSync3;
	ModestAction* rdt_rcv_packet_43;
	ModestAction* rdt_send_4;
	ModestAction* tau_37;
	ModestAction* tau_41;
	ModestAction* tau_23;
	ModestSyncAction* udt_send_ACKSync4;
	ModestAction* udt_send_ACK_30;
	ModestAction* udt_send_ACK_48;
	ModestSyncAction* udt_send_NAKSync5;
	ModestAction* udt_send_NAK_25;
	ModestAction* udt_send_NAK_45;
	ModestSyncAction* udt_send_packetSync6;
	ModestAction* udt_send_packet_8;
	ModestAction* udt_send_packet_34;
	ModestSyncAction* udt_send_packetSync7;
	ModestAction* udt_send_packet_12;

	// StateVariables for the static state bits
	ModestStateBit bit0;
	ModestStateBit bit1;
	ModestStateBit bit2;
	ModestStateBit bit3;
	ModestStateBit bit4;
	ModestStateBit bit5;
	ModestStateBit bit6;
	ModestStateBit bit7;
	ModestStateBit bit8;
	ModestStateBit bit9;
	ModestStateBit bit10;
	ModestStateBit bit11;
	ModestStateBit bit12;
	ModestStateBit bit13;
	ModestStateBit bit14;
	ModestStateBit bit15;
	ModestStateBit bit16;
	ModestStateBit bit17;
	ModestStateBit bit18;
	ModestStateBit bit19;
	ModestStateBit bit20;
	ModestStateBit bit21;
	ModestStateBit bit22;

	// Attributes for guards
	ModestGuard* guard22;
	ModestGuard* guard27;

	bitvector_type enabling_bits[1];
}; // end ModestModel rdt2_0
#endif
