#include "/home/pulungan/tools/mobius/MobiusProject/rdt/Atomic/rdt4_0/rdt4_0EXT.h"

PACKET::PACKET(char* name)
: ModestStructVariable<state_PACKET>(name)
{
	seq_num = new ModestVariable<int>("seq_num");
	fields.push_back( field(Int, seq_num) );
	type = new ModestVariable<int>("type");
	fields.push_back( field(Int, type) );
	status = new ModestVariable<int>("status");
	fields.push_back( field(Int, status) );
}

// per default include all parts of the file
#define MODEST_INCLUDE_GUARDS
#define MODEST_INCLUDE_PARAMETER_PASSERS
#define MODEST_INCLUDE_ASSIGNMENTS
#define MODEST_INCLUDE_MODEL

#ifdef MODEST_TEST_GUARDS
# define MODEST_INCLUDE_GUARDS
# undef MODEST_INCLUDE_PARAMETER_PASSERS
# undef MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif
#ifdef MODEST_TEST_PARAMETER_PASSERS
# undef MODEST_INCLUDE_GUARDS
# define MODEST_INCLUDE_PARAMETER_PASSERS
# undef MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif
#ifdef MODEST_TEST_ASSIGNMENTS
# undef MODEST_INCLUDE_GUARDS
# undef MODEST_INCLUDE_PARAMETER_PASSERS
# define MODEST_INCLUDE_ASSIGNMENTS
# undef MODEST_INCLUDE_MODEL
#endif

#ifdef MODEST_INCLUDE_GUARDS
	class Guard_13_0 : public ModestGuard {
	public:
		Guard_13_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 0 /* constant DATA */  );
		}
		PACKET* g_packet;
	};

	class Guard_13_1 : public ModestGuard {
	public:
		Guard_13_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 0 /* constant CORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_13_2 : public ModestGuard {
	public:
		Guard_13_2( ModestVariable<int>* l__snd_i, PACKET* g__packet )
		: ModestGuard()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == (1 - l_snd_i->getValue(/*wid*/)) );
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
	};

	class Guard_18_0 : public ModestGuard {
	public:
		Guard_18_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 0 /* constant DATA */  );
		}
		PACKET* g_packet;
	};

	class Guard_18_1 : public ModestGuard {
	public:
		Guard_18_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 1 /* constant NOTCORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_18_2 : public ModestGuard {
	public:
		Guard_18_2( ModestVariable<int>* l__snd_i, PACKET* g__packet )
		: ModestGuard()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == l_snd_i->getValue(/*wid*/) );
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
	};

	class Guard_27_0 : public ModestGuard {
	public:
		Guard_27_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 1 /* constant ACK */  );
		}
		PACKET* g_packet;
	};

	class Guard_41_0 : public TimedGuard {
	public:
		Guard_41_0( ModestVariable<double>* l__x, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) < timeout /* model parameter */  );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (timeout /* model parameter */  ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::DOWN, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};

	class Guard_47_0 : public ModestGuard {
	public:
		Guard_47_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 1 /* constant ACK */  );
		}
		PACKET* g_packet;
	};

	class Guard_47_1 : public ModestGuard {
	public:
		Guard_47_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 0 /* constant CORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_47_2 : public ModestGuard {
	public:
		Guard_47_2( ModestVariable<int>* l__snd_o, PACKET* g__packet )
		: ModestGuard()
		, l_snd_o(l__snd_o)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == (1 - l_snd_o->getValue(/*wid*/)) );
		}
		ModestVariable<int>* l_snd_o;
		PACKET* g_packet;
	};

	class Guard_55_0 : public ModestGuard {
	public:
		Guard_55_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 1 /* constant ACK */  );
		}
		PACKET* g_packet;
	};

	class Guard_55_1 : public ModestGuard {
	public:
		Guard_55_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 1 /* constant NOTCORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_55_2 : public ModestGuard {
	public:
		Guard_55_2( ModestVariable<int>* l__snd_o, PACKET* g__packet )
		: ModestGuard()
		, l_snd_o(l__snd_o)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == l_snd_o->getValue(/*wid*/) );
		}
		ModestVariable<int>* l_snd_o;
		PACKET* g_packet;
	};

	class Guard_61_0 : public ModestGuard {
	public:
		Guard_61_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 0 /* constant DATA */  );
		}
		PACKET* g_packet;
	};

	class Guard_61_1 : public ModestGuard {
	public:
		Guard_61_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 0 /* constant CORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_61_2 : public ModestGuard {
	public:
		Guard_61_2( ModestVariable<int>* l__snd_i, PACKET* g__packet )
		: ModestGuard()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == (1 - l_snd_i->getValue(/*wid*/)) );
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
	};

	class Guard_66_0 : public ModestGuard {
	public:
		Guard_66_0( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->type->getValue(/*str*/) == 0 /* constant DATA */  );
		}
		PACKET* g_packet;
	};

	class Guard_66_1 : public ModestGuard {
	public:
		Guard_66_1( PACKET* g__packet )
		: ModestGuard()
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->status->getValue(/*str*/) == 1 /* constant NOTCORRUPT */  );
		}
		PACKET* g_packet;
	};

	class Guard_66_2 : public ModestGuard {
	public:
		Guard_66_2( ModestVariable<int>* l__snd_i, PACKET* g__packet )
		: ModestGuard()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		{
		}
		bool isTrue( void ) const
		{
			return ( g_packet->seq_num->getValue(/*str*/) == l_snd_i->getValue(/*wid*/) );
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
	};

	class Guard_78_0 : public TimedGuard {
	public:
		Guard_78_0( ModestVariable<double>* l__x, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= timeout /* model parameter */  );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (timeout /* model parameter */  ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};

	class Guard_77_0 : public TimedGuard {
	public:
		Guard_77_0( ModestVariable<double>* l__x, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= timeout /* model parameter */  );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (timeout /* model parameter */  ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};

	class Guard_103_0 : public TimedGuard {
	public:
		Guard_103_0( ModestVariable<double>* l__x, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= lprop /* model parameter */  );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (lprop /* model parameter */  ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};

	class Guard_102_0 : public TimedGuard {
	public:
		Guard_102_0( ModestVariable<double>* l__x, ModestVariable<double>* l__prop, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, l_prop(l__prop)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= l_prop->getValue(/*wid*/) );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (l_prop->getValue(/*wid*/) ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestVariable<double>* l_prop;
		ModestModel* model;
	};

	class Guard_123_0 : public TimedGuard {
	public:
		Guard_123_0( ModestVariable<double>* l__x, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= lprop /* model parameter */  );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (lprop /* model parameter */  ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};

	class Guard_122_0 : public TimedGuard {
	public:
		Guard_122_0( ModestVariable<double>* l__x, ModestVariable<double>* l__prop, ModestModel* m )
		: TimedGuard()
		, l_x(l__x)
		, l_prop(l__prop)
		, model(m)
		{
		}
		bool isTrue( void ) const
		{
			return ( ( model->getGlobalClock() - l_x->getValue(/*wid*/)) >= l_prop->getValue(/*wid*/) );
		}
		    const BoolFun getBoolFun( void )
		{
			return BoolFun( (l_prop->getValue(/*wid*/) ) - (( model->getGlobalClock() - l_x->getValue(/*wid*/))), BoolFun::UP, BoolFun::CLOSED);
		}
		ModestVariable<double>* l_x;
		ModestVariable<double>* l_prop;
		ModestModel* model;
	};


#endif // MODEST_INCLUDE_GUARDS

#ifdef MODEST_INCLUDE_PARAMETER_PASSERS

#endif // MODEST_INCLUDE_PARAMETER_PASSERS

#ifdef MODEST_INCLUDE_ASSIGNMENTS
	class Assign_125_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_pcto1->setValue( 0 );
			g_pctc1->setValue( 0 );
			g_pcts1->setValue( 0 );
			g_pctl1->setValue( 0 );
		}
		Assign_125_0( ModestVariable<int>* g__pcto1, ModestVariable<int>* g__pctc1, ModestVariable<int>* g__pcts1, ModestVariable<int>* g__pctl1 )
		: ModestAssignmentFunctor()
		, g_pcto1(g__pcto1)
		, g_pctc1(g__pctc1)
		, g_pcts1(g__pcts1)
		, g_pctl1(g__pctl1)
		{
		}
		ModestVariable<int>* g_pcto1;
		ModestVariable<int>* g_pctc1;
		ModestVariable<int>* g_pcts1;
		ModestVariable<int>* g_pctl1;
	};
	class Assign_1_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_snd_i->setValue( 0 );
			l_snd_o->setValue( 0 );
		}
		Assign_1_0( ModestVariable<int>* l__snd_o, ModestVariable<int>* l__snd_i )
		: ModestAssignmentFunctor()
		, l_snd_o(l__snd_o)
		, l_snd_i(l__snd_i)
		{
		}
		ModestVariable<int>* l_snd_o;
		ModestVariable<int>* l_snd_i;
	};
	class Assign_11_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->setValue( l_pa->getValue(/*wid*/) );
		}
		Assign_11_0( PACKET* g__packet, PACKET* l__pa )
		: ModestAssignmentFunctor()
		, g_packet(g__packet)
		, l_pa(l__pa)
		{
		}
		PACKET* g_packet;
		PACKET* l_pa;
	};
	class Assign_21_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_pa->seq_num->setValue( l_snd_i->getValue(/*wid*/) );
			l_pa->type->setValue( 1 /* constant ACK */  );
			l_pa->status->setValue( 1 /* constant NOTCORRUPT */  );
			g_packet->setValue( l_pa->getValue(/*wid*/) );
			l_snd_i->setValue( (1 - l_snd_i->getValue(/*wid*/)) );
		}
		Assign_21_0( ModestVariable<int>* l__snd_i, PACKET* g__packet, PACKET* l__pa )
		: ModestAssignmentFunctor()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		, l_pa(l__pa)
		{
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
		PACKET* l_pa;
	};
	class Assign_32_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_pd->seq_num->setValue( l_snd_o->getValue(/*wid*/) );
			l_pd->type->setValue( 0 /* constant DATA */  );
			l_pd->status->setValue( 1 /* constant NOTCORRUPT */  );
			g_packet->setValue( l_pd->getValue(/*wid*/) );
		}
		Assign_32_0( PACKET* l__pd, ModestVariable<int>* l__snd_o, PACKET* g__packet )
		: ModestAssignmentFunctor()
		, l_pd(l__pd)
		, l_snd_o(l__snd_o)
		, g_packet(g__packet)
		{
		}
		PACKET* l_pd;
		ModestVariable<int>* l_snd_o;
		PACKET* g_packet;
	};
	class Assign_35_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_x->setValue( model->getGlobalClock() );
		}
		Assign_35_0( ModestVariable<double>* l__x, ModestModel* m )
		: ModestAssignmentFunctor()
		, l_x(l__x)
		, model(m)
		{
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};
	class Assign_45_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->setValue( l_pd->getValue(/*wid*/) );
		}
		Assign_45_0( PACKET* l__pd, PACKET* g__packet )
		: ModestAssignmentFunctor()
		, l_pd(l__pd)
		, g_packet(g__packet)
		{
		}
		PACKET* l_pd;
		PACKET* g_packet;
	};
	class Assign_49_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_x->setValue( model->getGlobalClock() );
		}
		Assign_49_0( ModestVariable<double>* l__x, ModestModel* m )
		: ModestAssignmentFunctor()
		, l_x(l__x)
		, model(m)
		{
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};
	class Assign_53_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_snd_o->setValue( (1 - l_snd_o->getValue(/*wid*/)) );
		}
		Assign_53_0( ModestVariable<int>* l__snd_o )
		: ModestAssignmentFunctor()
		, l_snd_o(l__snd_o)
		{
		}
		ModestVariable<int>* l_snd_o;
	};
	class Assign_59_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->setValue( l_pa->getValue(/*wid*/) );
		}
		Assign_59_0( PACKET* g__packet, PACKET* l__pa )
		: ModestAssignmentFunctor()
		, g_packet(g__packet)
		, l_pa(l__pa)
		{
		}
		PACKET* g_packet;
		PACKET* l_pa;
	};
	class Assign_69_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_pa->seq_num->setValue( l_snd_i->getValue(/*wid*/) );
			l_pa->type->setValue( 1 /* constant ACK */  );
			l_pa->status->setValue( 1 /* constant NOTCORRUPT */  );
			g_packet->setValue( l_pa->getValue(/*wid*/) );
			l_snd_i->setValue( (1 - l_snd_i->getValue(/*wid*/)) );
		}
		Assign_69_0( ModestVariable<int>* l__snd_i, PACKET* g__packet, PACKET* l__pa )
		: ModestAssignmentFunctor()
		, l_snd_i(l__snd_i)
		, g_packet(g__packet)
		, l_pa(l__pa)
		{
		}
		ModestVariable<int>* l_snd_i;
		PACKET* g_packet;
		PACKET* l_pa;
	};
	class Assign_75_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->setValue( l_pd->getValue(/*wid*/) );
		}
		Assign_75_0( PACKET* l__pd, PACKET* g__packet )
		: ModestAssignmentFunctor()
		, l_pd(l__pd)
		, g_packet(g__packet)
		{
		}
		PACKET* l_pd;
		PACKET* g_packet;
	};
	class Assign_80_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_x->setValue( model->getGlobalClock() );
		}
		Assign_80_0( ModestVariable<double>* l__x, ModestModel* m )
		: ModestAssignmentFunctor()
		, l_x(l__x)
		, model(m)
		{
		}
		ModestVariable<double>* l_x;
		ModestModel* model;
	};
	class Assign_85_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_x->setValue( model->getGlobalClock() );
			l_prop->setValue( TheDistribution->Uniform(lprop /* model parameter */ , uprop /* model parameter */ ) );
		}
		Assign_85_0( ModestVariable<double>* l__x, ModestVariable<double>* l__prop, ModestModel* m )
		: ModestAssignmentFunctor()
		, l_x(l__x)
		, l_prop(l__prop)
		, model(m)
		{
		}
		ModestVariable<double>* l_x;
		ModestVariable<double>* l_prop;
		ModestModel* model;
	};
	class Assign_93_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_pcto1->setValue( g_pcto1->getValue(/*wid*/) + 1 );
		}
		Assign_93_0( ModestVariable<int>* g__pcto1 )
		: ModestAssignmentFunctor()
		, g_pcto1(g__pcto1)
		{
		}
		ModestVariable<int>* g_pcto1;
	};
	class Assign_93_1 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->status->setValue( 0 /* constant CORRUPT */  );
			g_pctc1->setValue( g_pctc1->getValue(/*wid*/) + 1 );
		}
		Assign_93_1( ModestVariable<int>* g__pctc1, PACKET* g__packet )
		: ModestAssignmentFunctor()
		, g_pctc1(g__pctc1)
		, g_packet(g__packet)
		{
		}
		ModestVariable<int>* g_pctc1;
		PACKET* g_packet;
	};
	class Assign_93_2 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->seq_num->setValue( (1 - g_packet->seq_num->getValue(/*str*/)) );
			g_pcts1->setValue( g_pcts1->getValue(/*wid*/) + 1 );
		}
		Assign_93_2( ModestVariable<int>* g__pcts1, PACKET* g__packet )
		: ModestAssignmentFunctor()
		, g_pcts1(g__pcts1)
		, g_packet(g__packet)
		{
		}
		ModestVariable<int>* g_pcts1;
		PACKET* g_packet;
	};
	class Assign_93_3 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_pctl1->setValue( g_pctl1->getValue(/*wid*/) + 1 );
		}
		Assign_93_3( ModestVariable<int>* g__pctl1 )
		: ModestAssignmentFunctor()
		, g_pctl1(g__pctl1)
		{
		}
		ModestVariable<int>* g_pctl1;
	};
	class Assign_105_0 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			l_x->setValue( model->getGlobalClock() );
			l_prop->setValue( TheDistribution->Uniform(lprop /* model parameter */ , uprop /* model parameter */ ) );
		}
		Assign_105_0( ModestVariable<double>* l__x, ModestVariable<double>* l__prop, ModestModel* m )
		: ModestAssignmentFunctor()
		, l_x(l__x)
		, l_prop(l__prop)
		, model(m)
		{
		}
		ModestVariable<double>* l_x;
		ModestVariable<double>* l_prop;
		ModestModel* model;
	};
	class Assign_113_1 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->status->setValue( 0 /* constant CORRUPT */  );
		}
		Assign_113_1( PACKET* g__packet )
		: ModestAssignmentFunctor()
		, g_packet(g__packet)
		{
		}
		PACKET* g_packet;
	};
	class Assign_113_2 : public ModestAssignmentFunctor {
	public:
		void operator() ()
		{
			g_packet->seq_num->setValue( (1 - g_packet->seq_num->getValue(/*str*/)) );
		}
		Assign_113_2( PACKET* g__packet )
		: ModestAssignmentFunctor()
		, g_packet(g__packet)
		{
		}
		PACKET* g_packet;
	};

#endif // MODEST_INCLUDE_ASSIGNMENTS

#ifdef MODEST_INCLUDE_MODEL

static const rdt4_0EXT::mask_type bitmasks_local = {
	  { 0x1, 0, 0 } // Root Process Enable Mask
	, { 0xffffffff, 0xffffffff, 0x1fff }
	, { 0, 0, 0 }
	, { 0x2, 0x2, 0x82 }
	, { 0xfffffffe, 0xffffffff, 0x1fff }
	, { 0x2, 0, 0 }
	, { 0xfffffffe, 0x1, 0 }
	, { 0x804, 0, 0 }
	, { 0xfffffffc, 0x1, 0 }
	, { 0x1ffc, 0, 0 }
	, { 0x4, 0, 0 }
	, { 0x7fc, 0, 0 }
	, { 0x428, 0, 0 }
	, { 0x7f8, 0, 0 }
	, { 0x8, 0, 0 }
	, { 0x18, 0, 0 }
	, { 0x10, 0, 0 }
	, { 0x20, 0, 0 }
	, { 0x3e0, 0, 0 }
	, { 0x40, 0, 0 }
	, { 0x80, 0, 0 }
	, { 0x100, 0, 0 }
	, { 0x200, 0, 0 }
	, { 0x400, 0, 0 }
	, { 0x800, 0, 0 }
	, { 0x1800, 0, 0 }
	, { 0x1000, 0, 0 }
	, { 0x2000, 0, 0 }
	, { 0x4000, 0, 0 }
	, { 0x8000, 0, 0 }
	, { 0x10000, 0, 0 }
	, { 0x40020000, 0, 0 }
	, { 0xfffe0000, 0x1, 0 }
	, { 0x20000, 0, 0 }
	, { 0x3ffe0000, 0, 0 }
	, { 0x2a40000, 0, 0 }
	, { 0x3ffc0000, 0, 0 }
	, { 0x40000, 0, 0 }
	, { 0x1c0000, 0, 0 }
	, { 0x80000, 0, 0 }
	, { 0x100000, 0, 0 }
	, { 0x200000, 0, 0 }
	, { 0x600000, 0, 0 }
	, { 0x400000, 0, 0 }
	, { 0x800000, 0, 0 }
	, { 0x1800000, 0, 0 }
	, { 0x1000000, 0, 0 }
	, { 0x2000000, 0, 0 }
	, { 0x3e000000, 0, 0 }
	, { 0x4000000, 0, 0 }
	, { 0x8000000, 0, 0 }
	, { 0x10000000, 0, 0 }
	, { 0x20000000, 0, 0 }
	, { 0x40000000, 0, 0 }
	, { 0xc0000000, 0x1, 0 }
	, { 0x80000000, 0, 0 }
	, { 0, 0x1, 0 }
	, { 0, 0x2, 0 }
	, { 0, 0xfffffffe, 0x1 }
	, { 0, 0x804, 0 }
	, { 0, 0xfffffffc, 0x1 }
	, { 0, 0x1ffc, 0 }
	, { 0, 0x4, 0 }
	, { 0, 0x7fc, 0 }
	, { 0, 0x428, 0 }
	, { 0, 0x7f8, 0 }
	, { 0, 0x8, 0 }
	, { 0, 0x18, 0 }
	, { 0, 0x10, 0 }
	, { 0, 0x20, 0 }
	, { 0, 0x3e0, 0 }
	, { 0, 0x40, 0 }
	, { 0, 0x80, 0 }
	, { 0, 0x100, 0 }
	, { 0, 0x200, 0 }
	, { 0, 0x400, 0 }
	, { 0, 0x800, 0 }
	, { 0, 0x1800, 0 }
	, { 0, 0x1000, 0 }
	, { 0, 0x2000, 0 }
	, { 0, 0x4000, 0 }
	, { 0, 0x8000, 0 }
	, { 0, 0x10000, 0 }
	, { 0, 0x40020000, 0 }
	, { 0, 0xfffe0000, 0x1 }
	, { 0, 0x20000, 0 }
	, { 0, 0x3ffe0000, 0 }
	, { 0, 0x2a40000, 0 }
	, { 0, 0x3ffc0000, 0 }
	, { 0, 0x40000, 0 }
	, { 0, 0x1c0000, 0 }
	, { 0, 0x80000, 0 }
	, { 0, 0x100000, 0 }
	, { 0, 0x200000, 0 }
	, { 0, 0x600000, 0 }
	, { 0, 0x400000, 0 }
	, { 0, 0x800000, 0 }
	, { 0, 0x1800000, 0 }
	, { 0, 0x1000000, 0 }
	, { 0, 0x2000000, 0 }
	, { 0, 0x3e000000, 0 }
	, { 0, 0x4000000, 0 }
	, { 0, 0x8000000, 0 }
	, { 0, 0x10000000, 0 }
	, { 0, 0x20000000, 0 }
	, { 0, 0x40000000, 0 }
	, { 0, 0xc0000000, 0x1 }
	, { 0, 0x80000000, 0 }
	, { 0, 0, 0x1 }
	, { 0, 0, 0x82 }
	, { 0, 0, 0x1ffe }
	, { 0, 0, 0x2 }
	, { 0, 0, 0x7e }
	, { 0, 0, 0x4 }
	, { 0, 0, 0x7c }
	, { 0, 0, 0x8 }
	, { 0, 0, 0x10 }
	, { 0, 0, 0x20 }
	, { 0, 0, 0x40 }
	, { 0, 0, 0x80 }
	, { 0, 0, 0x1f80 }
	, { 0, 0, 0x100 }
	, { 0, 0, 0x1f00 }
	, { 0, 0, 0x200 }
	, { 0, 0, 0x400 }
	, { 0, 0, 0x800 }
	, { 0, 0, 0x1000 }
};

rdt4_0EXT::mask_type* rdt4_0EXT::bitmasks = &bitmasks_local;

void rdt4_0EXT::CurrentState( void* memory )
{
	StateStruct* ss = static_cast<StateStruct*>(memory);

	std::memcpy( ss->enabling_bits, enabling_bits, 3*sizeof(bitvector_type));
	ss->pa_sender1 = pa_sender1->getValue();
	ss->pa_sender2 = pa_sender2->getValue();
	ss->packet = packet->getValue();
	ss->pctc1 = pctc1->getValue();
	ss->pctl1 = pctl1->getValue();
	ss->pcto1 = pcto1->getValue();
	ss->pcts1 = pcts1->getValue();
	ss->pd_sender1 = pd_sender1->getValue();
	ss->pd_sender2 = pd_sender2->getValue();
	ss->prop_channel1 = prop_channel1->getValue();
	ss->snd_i_sender1 = snd_i_sender1->getValue();
	ss->snd_i_sender2 = snd_i_sender2->getValue();
	ss->snd_o_sender1 = snd_o_sender1->getValue();
	ss->snd_o_sender2 = snd_o_sender2->getValue();
	ss->x_channel1 = x_channel1->getValue();
	ss->x_sender1 = x_sender1->getValue();
	ss->x_sender2 = x_sender2->getValue();
}

void rdt4_0EXT::SetState( void* memory )
{
	StateStruct* ss = static_cast<StateStruct*>(memory);

	std::memcpy( enabling_bits, ss->enabling_bits, 3*sizeof(bitvector_type));
	pa_sender1->setValue(ss->pa_sender1);
	pa_sender2->setValue(ss->pa_sender2);
	packet->setValue(ss->packet);
	pctc1->setValue(ss->pctc1);
	pctl1->setValue(ss->pctl1);
	pcto1->setValue(ss->pcto1);
	pcts1->setValue(ss->pcts1);
	pd_sender1->setValue(ss->pd_sender1);
	pd_sender2->setValue(ss->pd_sender2);
	prop_channel1->setValue(ss->prop_channel1);
	snd_i_sender1->setValue(ss->snd_i_sender1);
	snd_i_sender2->setValue(ss->snd_i_sender2);
	snd_o_sender1->setValue(ss->snd_o_sender1);
	snd_o_sender2->setValue(ss->snd_o_sender2);
	x_channel1->setValue(ss->x_channel1);
	x_sender1->setValue(ss->x_sender1);
	x_sender2->setValue(ss->x_sender2);
}

void rdt4_0EXT::printState( std::ostream *strm )
{
	(*strm)
		<< "bit0 = " << ((enabling_bits[0] & 1UL) != 0) << std::endl
		<< "bit1 = " << ((enabling_bits[0] & 2UL) != 0) << std::endl
		<< "bit2 = " << ((enabling_bits[0] & 4UL) != 0) << std::endl
		<< "bit3 = " << ((enabling_bits[0] & 8UL) != 0) << std::endl
		<< "bit4 = " << ((enabling_bits[0] & 16UL) != 0) << std::endl
		<< "bit5 = " << ((enabling_bits[0] & 32UL) != 0) << std::endl
		<< "bit6 = " << ((enabling_bits[0] & 64UL) != 0) << std::endl
		<< "bit7 = " << ((enabling_bits[0] & 128UL) != 0) << std::endl
		<< "bit8 = " << ((enabling_bits[0] & 256UL) != 0) << std::endl
		<< "bit9 = " << ((enabling_bits[0] & 512UL) != 0) << std::endl
		<< "bit10 = " << ((enabling_bits[0] & 1024UL) != 0) << std::endl
		<< "bit11 = " << ((enabling_bits[0] & 2048UL) != 0) << std::endl
		<< "bit12 = " << ((enabling_bits[0] & 4096UL) != 0) << std::endl
		<< "bit13 = " << ((enabling_bits[0] & 8192UL) != 0) << std::endl
		<< "bit14 = " << ((enabling_bits[0] & 16384UL) != 0) << std::endl
		<< "bit15 = " << ((enabling_bits[0] & 32768UL) != 0) << std::endl
		<< "bit16 = " << ((enabling_bits[0] & 65536UL) != 0) << std::endl
		<< "bit17 = " << ((enabling_bits[0] & 131072UL) != 0) << std::endl
		<< "bit18 = " << ((enabling_bits[0] & 262144UL) != 0) << std::endl
		<< "bit19 = " << ((enabling_bits[0] & 524288UL) != 0) << std::endl
		<< "bit20 = " << ((enabling_bits[0] & 1048576UL) != 0) << std::endl
		<< "bit21 = " << ((enabling_bits[0] & 2097152UL) != 0) << std::endl
		<< "bit22 = " << ((enabling_bits[0] & 4194304UL) != 0) << std::endl
		<< "bit23 = " << ((enabling_bits[0] & 8388608UL) != 0) << std::endl
		<< "bit24 = " << ((enabling_bits[0] & 16777216UL) != 0) << std::endl
		<< "bit25 = " << ((enabling_bits[0] & 33554432UL) != 0) << std::endl
		<< "bit26 = " << ((enabling_bits[0] & 67108864UL) != 0) << std::endl
		<< "bit27 = " << ((enabling_bits[0] & 134217728UL) != 0) << std::endl
		<< "bit28 = " << ((enabling_bits[0] & 268435456UL) != 0) << std::endl
		<< "bit29 = " << ((enabling_bits[0] & 536870912UL) != 0) << std::endl
		<< "bit30 = " << ((enabling_bits[0] & 1073741824UL) != 0) << std::endl
		<< "bit31 = " << ((enabling_bits[0] & 2147483648UL) != 0) << std::endl
		<< "bit32 = " << ((enabling_bits[1] & 1UL) != 0) << std::endl
		<< "bit33 = " << ((enabling_bits[1] & 2UL) != 0) << std::endl
		<< "bit34 = " << ((enabling_bits[1] & 4UL) != 0) << std::endl
		<< "bit35 = " << ((enabling_bits[1] & 8UL) != 0) << std::endl
		<< "bit36 = " << ((enabling_bits[1] & 16UL) != 0) << std::endl
		<< "bit37 = " << ((enabling_bits[1] & 32UL) != 0) << std::endl
		<< "bit38 = " << ((enabling_bits[1] & 64UL) != 0) << std::endl
		<< "bit39 = " << ((enabling_bits[1] & 128UL) != 0) << std::endl
		<< "bit40 = " << ((enabling_bits[1] & 256UL) != 0) << std::endl
		<< "bit41 = " << ((enabling_bits[1] & 512UL) != 0) << std::endl
		<< "bit42 = " << ((enabling_bits[1] & 1024UL) != 0) << std::endl
		<< "bit43 = " << ((enabling_bits[1] & 2048UL) != 0) << std::endl
		<< "bit44 = " << ((enabling_bits[1] & 4096UL) != 0) << std::endl
		<< "bit45 = " << ((enabling_bits[1] & 8192UL) != 0) << std::endl
		<< "bit46 = " << ((enabling_bits[1] & 16384UL) != 0) << std::endl
		<< "bit47 = " << ((enabling_bits[1] & 32768UL) != 0) << std::endl
		<< "bit48 = " << ((enabling_bits[1] & 65536UL) != 0) << std::endl
		<< "bit49 = " << ((enabling_bits[1] & 131072UL) != 0) << std::endl
		<< "bit50 = " << ((enabling_bits[1] & 262144UL) != 0) << std::endl
		<< "bit51 = " << ((enabling_bits[1] & 524288UL) != 0) << std::endl
		<< "bit52 = " << ((enabling_bits[1] & 1048576UL) != 0) << std::endl
		<< "bit53 = " << ((enabling_bits[1] & 2097152UL) != 0) << std::endl
		<< "bit54 = " << ((enabling_bits[1] & 4194304UL) != 0) << std::endl
		<< "bit55 = " << ((enabling_bits[1] & 8388608UL) != 0) << std::endl
		<< "bit56 = " << ((enabling_bits[1] & 16777216UL) != 0) << std::endl
		<< "bit57 = " << ((enabling_bits[1] & 33554432UL) != 0) << std::endl
		<< "bit58 = " << ((enabling_bits[1] & 67108864UL) != 0) << std::endl
		<< "bit59 = " << ((enabling_bits[1] & 134217728UL) != 0) << std::endl
		<< "bit60 = " << ((enabling_bits[1] & 268435456UL) != 0) << std::endl
		<< "bit61 = " << ((enabling_bits[1] & 536870912UL) != 0) << std::endl
		<< "bit62 = " << ((enabling_bits[1] & 1073741824UL) != 0) << std::endl
		<< "bit63 = " << ((enabling_bits[1] & 2147483648UL) != 0) << std::endl
		<< "bit64 = " << ((enabling_bits[2] & 1UL) != 0) << std::endl
		<< "bit65 = " << ((enabling_bits[2] & 2UL) != 0) << std::endl
		<< "bit66 = " << ((enabling_bits[2] & 4UL) != 0) << std::endl
		<< "bit67 = " << ((enabling_bits[2] & 8UL) != 0) << std::endl
		<< "bit68 = " << ((enabling_bits[2] & 16UL) != 0) << std::endl
		<< "bit69 = " << ((enabling_bits[2] & 32UL) != 0) << std::endl
		<< "bit70 = " << ((enabling_bits[2] & 64UL) != 0) << std::endl
		<< "bit71 = " << ((enabling_bits[2] & 128UL) != 0) << std::endl
		<< "bit72 = " << ((enabling_bits[2] & 256UL) != 0) << std::endl
		<< "bit73 = " << ((enabling_bits[2] & 512UL) != 0) << std::endl
		<< "bit74 = " << ((enabling_bits[2] & 1024UL) != 0) << std::endl
		<< "bit75 = " << ((enabling_bits[2] & 2048UL) != 0) << std::endl
		<< "bit76 = " << ((enabling_bits[2] & 4096UL) != 0) << std::endl
		<< "pa_sender1 = " << pa_sender1->getValue() << std::endl
		<< "pa_sender2 = " << pa_sender2->getValue() << std::endl
		<< "packet = " << packet->getValue() << std::endl
		<< "pctc1 = " << pctc1->getValue() << std::endl
		<< "pctl1 = " << pctl1->getValue() << std::endl
		<< "pcto1 = " << pcto1->getValue() << std::endl
		<< "pcts1 = " << pcts1->getValue() << std::endl
		<< "pd_sender1 = " << pd_sender1->getValue() << std::endl
		<< "pd_sender2 = " << pd_sender2->getValue() << std::endl
		<< "prop_channel1 = " << prop_channel1->getValue() << std::endl
		<< "snd_i_sender1 = " << snd_i_sender1->getValue() << std::endl
		<< "snd_i_sender2 = " << snd_i_sender2->getValue() << std::endl
		<< "snd_o_sender1 = " << snd_o_sender1->getValue() << std::endl
		<< "snd_o_sender2 = " << snd_o_sender2->getValue() << std::endl
		<< "x_channel1 = " << x_channel1->getValue() << std::endl
		<< "x_sender1 = " << x_sender1->getValue() << std::endl
		<< "x_sender2 = " << x_sender2->getValue() << std::endl
		;
}
rdt4_0EXT::~rdt4_0EXT()
{
	if( term_tree ) delete term_tree;
	if( con ) delete [] con;
}

rdt4_0EXT::rdt4_0EXT()
: ModestModel()
, con(0)
, term_tree(0)
, pa_sender1( new PACKET( "pa_sender1" ) )
, pa_sender2( new PACKET( "pa_sender2" ) )
, packet( new PACKET( "packet" ) )
, pctc1( new ModestVariable<int>( "pctc1" ) )
, pctl1( new ModestVariable<int>( "pctl1" ) )
, pcto1( new ModestVariable<int>( "pcto1" ) )
, pcts1( new ModestVariable<int>( "pcts1" ) )
, pd_sender1( new PACKET( "pd_sender1" ) )
, pd_sender2( new PACKET( "pd_sender2" ) )
, prop_channel1( new ModestVariable<double>( "prop_channel1" ) )
, snd_i_sender1( new ModestVariable<int>( "snd_i_sender1" ) )
, snd_i_sender2( new ModestVariable<int>( "snd_i_sender2" ) )
, snd_o_sender1( new ModestVariable<int>( "snd_o_sender1" ) )
, snd_o_sender2( new ModestVariable<int>( "snd_o_sender2" ) )
, x_channel1( new ModestVariable<double>( "x_channel1" ) )
, x_sender1( new ModestVariable<double>( "x_sender1" ) )
, x_sender2( new ModestVariable<double>( "x_sender2" ) )
, break_34( new ModestAction( "break_34", 0, 0, 0x1000, this ) )
, break_57( new ModestAction( "break_57", 1, 0, 0x400000, this ) )
, break_108( new ModestAction( "break_108", 2, 1, 0x1000, this ) )
, break_131( new ModestAction( "break_131", 3, 1, 0x400000, this ) )
, rdt_rcv_1Sync0( new ModestSyncAction( "rdt_rcv_1Sync0", 4, this ) )
, rdt_rcv_15( new ModestAction( "rdt_rcv_15", 4, 0, 0x4, this ) )
, rdt_rcv_1_171( new ModestAction( "rdt_rcv_1_171", 4, 2, 0x200, this ) )
, rdt_rcv_1Sync1( new ModestSyncAction( "rdt_rcv_1Sync1", 5, this ) )
, rdt_rcv_1_172( new ModestAction( "rdt_rcv_1_172", 5, 2, 0x400, this ) )
, rdt_rcv_1Sync2( new ModestSyncAction( "rdt_rcv_1Sync2", 6, this ) )
, rdt_rcv_1_173( new ModestAction( "rdt_rcv_1_173", 6, 2, 0x800, this ) )
, rdt_rcv_1Sync3( new ModestSyncAction( "rdt_rcv_1Sync3", 7, this ) )
, rdt_rcv_44( new ModestAction( "rdt_rcv_44", 7, 0, 0x20000, this ) )
, rdt_rcv_1Sync4( new ModestSyncAction( "rdt_rcv_1Sync4", 8, this ) )
, rdt_rcv_1Sync5( new ModestSyncAction( "rdt_rcv_1Sync5", 9, this ) )
, rdt_rcv_2Sync6( new ModestSyncAction( "rdt_rcv_2Sync6", 10, this ) )
, rdt_rcv_89( new ModestAction( "rdt_rcv_89", 10, 1, 0x4, this ) )
, rdt_rcv_2_161( new ModestAction( "rdt_rcv_2_161", 10, 2, 0x8, this ) )
, rdt_rcv_2Sync7( new ModestSyncAction( "rdt_rcv_2Sync7", 11, this ) )
, rdt_rcv_2_162( new ModestAction( "rdt_rcv_2_162", 11, 2, 0x10, this ) )
, rdt_rcv_2Sync8( new ModestSyncAction( "rdt_rcv_2Sync8", 12, this ) )
, rdt_rcv_2_163( new ModestAction( "rdt_rcv_2_163", 12, 2, 0x20, this ) )
, rdt_rcv_2Sync9( new ModestSyncAction( "rdt_rcv_2Sync9", 13, this ) )
, rdt_rcv_118( new ModestAction( "rdt_rcv_118", 13, 1, 0x20000, this ) )
, rdt_rcv_2Sync10( new ModestSyncAction( "rdt_rcv_2Sync10", 14, this ) )
, rdt_rcv_2Sync11( new ModestSyncAction( "rdt_rcv_2Sync11", 15, this ) )
, tau_2( new ModestAction( "tau_2", 16, 0, 0x1, this ) )
, tau_160( new ModestAction( "tau_160", 17, 2, 0x4, this ) )
, tau_164( new ModestAction( "tau_164", 18, 2, 0x40, this ) )
, tau_170( new ModestAction( "tau_170", 19, 2, 0x100, this ) )
, tau_174( new ModestAction( "tau_174", 20, 2, 0x1000, this ) )
, compute_checksum_26( new ModestAction( "compute_checksum_26", 21, 0, 0x80, this ) )
, compute_checksum_35( new ModestAction( "compute_checksum_35", 22, 0, 0x2000, this ) )
, compute_checksum_67( new ModestAction( "compute_checksum_67", 23, 0, 0x8000000, this ) )
, deliver_data_25( new ModestAction( "deliver_data_25", 24, 0, 0x40, this ) )
, deliver_data_66( new ModestAction( "deliver_data_66", 25, 0, 0x4000000, this ) )
, extract_24( new ModestAction( "extract_24", 26, 0, 0x20, this ) )
, extract_65( new ModestAction( "extract_65", 27, 0, 0x2000000, this ) )
, make_pkt_27( new ModestAction( "make_pkt_27", 28, 0, 0x100, this ) )
, make_pkt_36( new ModestAction( "make_pkt_36", 29, 0, 0x4000, this ) )
, make_pkt_68( new ModestAction( "make_pkt_68", 30, 0, 0x10000000, this ) )
, rdt_send_33( new ModestAction( "rdt_send_33", 31, 0, 0x800, this ) )
, start_timer_39( new ModestAction( "start_timer_39", 32, 0, 0x10000, this ) )
, start_timer_51( new ModestAction( "start_timer_51", 33, 0, 0x100000, this ) )
, start_timer_77( new ModestAction( "start_timer_77", 34, 1, 0x1, this ) )
, tau_9( new ModestAction( "tau_9", 35, 0, 0x2, this ) )
, tau_19( new ModestAction( "tau_19", 36, 0, 0x8, this ) )
, tau_31( new ModestAction( "tau_31", 37, 0, 0x400, this ) )
, tau_48( new ModestAction( "tau_48", 38, 0, 0x40000, this ) )
, tau_55( new ModestAction( "tau_55", 39, 0, 0x200000, this ) )
, tau_60( new ModestAction( "tau_60", 40, 0, 0x800000, this ) )
, tau_74( new ModestAction( "tau_74", 41, 0, 0x40000000, this ) )
, compute_checksum_100( new ModestAction( "compute_checksum_100", 42, 1, 0x80, this ) )
, compute_checksum_109( new ModestAction( "compute_checksum_109", 43, 1, 0x2000, this ) )
, compute_checksum_141( new ModestAction( "compute_checksum_141", 44, 1, 0x8000000, this ) )
, deliver_data_99( new ModestAction( "deliver_data_99", 45, 1, 0x40, this ) )
, deliver_data_140( new ModestAction( "deliver_data_140", 46, 1, 0x4000000, this ) )
, extract_98( new ModestAction( "extract_98", 47, 1, 0x20, this ) )
, extract_139( new ModestAction( "extract_139", 48, 1, 0x2000000, this ) )
, make_pkt_101( new ModestAction( "make_pkt_101", 49, 1, 0x100, this ) )
, make_pkt_110( new ModestAction( "make_pkt_110", 50, 1, 0x4000, this ) )
, make_pkt_142( new ModestAction( "make_pkt_142", 51, 1, 0x10000000, this ) )
, rdt_send_107( new ModestAction( "rdt_send_107", 52, 1, 0x800, this ) )
, start_timer_113( new ModestAction( "start_timer_113", 53, 1, 0x10000, this ) )
, start_timer_125( new ModestAction( "start_timer_125", 54, 1, 0x100000, this ) )
, start_timer_151( new ModestAction( "start_timer_151", 55, 2, 0x1, this ) )
, tau_83( new ModestAction( "tau_83", 56, 1, 0x2, this ) )
, tau_93( new ModestAction( "tau_93", 57, 1, 0x8, this ) )
, tau_105( new ModestAction( "tau_105", 58, 1, 0x400, this ) )
, tau_122( new ModestAction( "tau_122", 59, 1, 0x40000, this ) )
, tau_129( new ModestAction( "tau_129", 60, 1, 0x200000, this ) )
, tau_134( new ModestAction( "tau_134", 61, 1, 0x800000, this ) )
, tau_148( new ModestAction( "tau_148", 62, 1, 0x40000000, this ) )
, udt_send_1Sync12( new ModestSyncAction( "udt_send_1Sync12", 63, this ) )
, udt_send_21( new ModestAction( "udt_send_21", 63, 0, 0x10, this ) )
, udt_send_1_156( new ModestAction( "udt_send_1_156", 63, 2, 0x2, this ) )
, udt_send_1Sync13( new ModestSyncAction( "udt_send_1Sync13", 64, this ) )
, udt_send_29( new ModestAction( "udt_send_29", 64, 0, 0x200, this ) )
, udt_send_1Sync14( new ModestSyncAction( "udt_send_1Sync14", 65, this ) )
, udt_send_38( new ModestAction( "udt_send_38", 65, 0, 0x8000, this ) )
, udt_send_1Sync15( new ModestSyncAction( "udt_send_1Sync15", 66, this ) )
, udt_send_50( new ModestAction( "udt_send_50", 66, 0, 0x80000, this ) )
, udt_send_1Sync16( new ModestSyncAction( "udt_send_1Sync16", 67, this ) )
, udt_send_62( new ModestAction( "udt_send_62", 67, 0, 0x1000000, this ) )
, udt_send_1Sync17( new ModestSyncAction( "udt_send_1Sync17", 68, this ) )
, udt_send_70( new ModestAction( "udt_send_70", 68, 0, 0x20000000, this ) )
, udt_send_1Sync18( new ModestSyncAction( "udt_send_1Sync18", 69, this ) )
, udt_send_76( new ModestAction( "udt_send_76", 69, 0, 0x80000000, this ) )
, udt_send_2Sync19( new ModestSyncAction( "udt_send_2Sync19", 70, this ) )
, udt_send_95( new ModestAction( "udt_send_95", 70, 1, 0x10, this ) )
, udt_send_2_166( new ModestAction( "udt_send_2_166", 70, 2, 0x80, this ) )
, udt_send_2Sync20( new ModestSyncAction( "udt_send_2Sync20", 71, this ) )
, udt_send_103( new ModestAction( "udt_send_103", 71, 1, 0x200, this ) )
, udt_send_2Sync21( new ModestSyncAction( "udt_send_2Sync21", 72, this ) )
, udt_send_112( new ModestAction( "udt_send_112", 72, 1, 0x8000, this ) )
, udt_send_2Sync22( new ModestSyncAction( "udt_send_2Sync22", 73, this ) )
, udt_send_124( new ModestAction( "udt_send_124", 73, 1, 0x80000, this ) )
, udt_send_2Sync23( new ModestSyncAction( "udt_send_2Sync23", 74, this ) )
, udt_send_136( new ModestAction( "udt_send_136", 74, 1, 0x1000000, this ) )
, udt_send_2Sync24( new ModestSyncAction( "udt_send_2Sync24", 75, this ) )
, udt_send_144( new ModestAction( "udt_send_144", 75, 1, 0x20000000, this ) )
, udt_send_2Sync25( new ModestSyncAction( "udt_send_2Sync25", 76, this ) )
, udt_send_150( new ModestAction( "udt_send_150", 76, 1, 0x80000000, this ) )
, bit0( "bit0", 0, enabling_bits, 3 )
, bit1( "bit1", 1, enabling_bits, 3 )
, bit2( "bit2", 2, enabling_bits, 3 )
, bit3( "bit3", 3, enabling_bits, 3 )
, bit4( "bit4", 4, enabling_bits, 3 )
, bit5( "bit5", 5, enabling_bits, 3 )
, bit6( "bit6", 6, enabling_bits, 3 )
, bit7( "bit7", 7, enabling_bits, 3 )
, bit8( "bit8", 8, enabling_bits, 3 )
, bit9( "bit9", 9, enabling_bits, 3 )
, bit10( "bit10", 10, enabling_bits, 3 )
, bit11( "bit11", 11, enabling_bits, 3 )
, bit12( "bit12", 12, enabling_bits, 3 )
, bit13( "bit13", 13, enabling_bits, 3 )
, bit14( "bit14", 14, enabling_bits, 3 )
, bit15( "bit15", 15, enabling_bits, 3 )
, bit16( "bit16", 16, enabling_bits, 3 )
, bit17( "bit17", 17, enabling_bits, 3 )
, bit18( "bit18", 18, enabling_bits, 3 )
, bit19( "bit19", 19, enabling_bits, 3 )
, bit20( "bit20", 20, enabling_bits, 3 )
, bit21( "bit21", 21, enabling_bits, 3 )
, bit22( "bit22", 22, enabling_bits, 3 )
, bit23( "bit23", 23, enabling_bits, 3 )
, bit24( "bit24", 24, enabling_bits, 3 )
, bit25( "bit25", 25, enabling_bits, 3 )
, bit26( "bit26", 26, enabling_bits, 3 )
, bit27( "bit27", 27, enabling_bits, 3 )
, bit28( "bit28", 28, enabling_bits, 3 )
, bit29( "bit29", 29, enabling_bits, 3 )
, bit30( "bit30", 30, enabling_bits, 3 )
, bit31( "bit31", 31, enabling_bits, 3 )
, bit32( "bit32", 32, enabling_bits, 3 )
, bit33( "bit33", 33, enabling_bits, 3 )
, bit34( "bit34", 34, enabling_bits, 3 )
, bit35( "bit35", 35, enabling_bits, 3 )
, bit36( "bit36", 36, enabling_bits, 3 )
, bit37( "bit37", 37, enabling_bits, 3 )
, bit38( "bit38", 38, enabling_bits, 3 )
, bit39( "bit39", 39, enabling_bits, 3 )
, bit40( "bit40", 40, enabling_bits, 3 )
, bit41( "bit41", 41, enabling_bits, 3 )
, bit42( "bit42", 42, enabling_bits, 3 )
, bit43( "bit43", 43, enabling_bits, 3 )
, bit44( "bit44", 44, enabling_bits, 3 )
, bit45( "bit45", 45, enabling_bits, 3 )
, bit46( "bit46", 46, enabling_bits, 3 )
, bit47( "bit47", 47, enabling_bits, 3 )
, bit48( "bit48", 48, enabling_bits, 3 )
, bit49( "bit49", 49, enabling_bits, 3 )
, bit50( "bit50", 50, enabling_bits, 3 )
, bit51( "bit51", 51, enabling_bits, 3 )
, bit52( "bit52", 52, enabling_bits, 3 )
, bit53( "bit53", 53, enabling_bits, 3 )
, bit54( "bit54", 54, enabling_bits, 3 )
, bit55( "bit55", 55, enabling_bits, 3 )
, bit56( "bit56", 56, enabling_bits, 3 )
, bit57( "bit57", 57, enabling_bits, 3 )
, bit58( "bit58", 58, enabling_bits, 3 )
, bit59( "bit59", 59, enabling_bits, 3 )
, bit60( "bit60", 60, enabling_bits, 3 )
, bit61( "bit61", 61, enabling_bits, 3 )
, bit62( "bit62", 62, enabling_bits, 3 )
, bit63( "bit63", 63, enabling_bits, 3 )
, bit64( "bit64", 64, enabling_bits, 3 )
, bit65( "bit65", 65, enabling_bits, 3 )
, bit66( "bit66", 66, enabling_bits, 3 )
, bit67( "bit67", 67, enabling_bits, 3 )
, bit68( "bit68", 68, enabling_bits, 3 )
, bit69( "bit69", 69, enabling_bits, 3 )
, bit70( "bit70", 70, enabling_bits, 3 )
, bit71( "bit71", 71, enabling_bits, 3 )
, bit72( "bit72", 72, enabling_bits, 3 )
, bit73( "bit73", 73, enabling_bits, 3 )
, bit74( "bit74", 74, enabling_bits, 3 )
, bit75( "bit75", 75, enabling_bits, 3 )
, bit76( "bit76", 76, enabling_bits, 3 )
, guard18(new AndGuard( new Guard_13_0(  packet ), new OrGuard( new Guard_13_1(  packet ), new Guard_13_2(  snd_i_sender1,  packet ))))
, guard23(new AndGuard( new AndGuard( new Guard_18_0(  packet ), new Guard_18_1(  packet )), new Guard_18_2(  snd_i_sender1,  packet )))
, guard30(new Guard_27_0(  packet ))
, guard43(new Guard_41_0(  x_sender1, this ))
, guard47(new AndGuard( new Guard_47_0(  packet ), new OrGuard( new Guard_47_1(  packet ), new Guard_47_2(  snd_o_sender1,  packet ))))
, guard54(new AndGuard( new AndGuard( new Guard_55_0(  packet ), new Guard_55_1(  packet )), new Guard_55_2(  snd_o_sender1,  packet )))
, guard59(new AndGuard( new Guard_61_0(  packet ), new OrGuard( new Guard_61_1(  packet ), new Guard_61_2(  snd_i_sender1,  packet ))))
, guard64(new AndGuard( new AndGuard( new Guard_66_0(  packet ), new Guard_66_1(  packet )), new Guard_66_2(  snd_i_sender1,  packet )))
, guard72(new Guard_78_0(  x_sender1, this ))
, guard73(new Guard_77_0(  x_sender1, this ))
, guard92(new AndGuard( new Guard_13_0(  packet ), new OrGuard( new Guard_13_1(  packet ), new Guard_13_2(  snd_i_sender2,  packet ))))
, guard97(new AndGuard( new AndGuard( new Guard_18_0(  packet ), new Guard_18_1(  packet )), new Guard_18_2(  snd_i_sender2,  packet )))
, guard104(new Guard_27_0(  packet ))
, guard117(new Guard_41_0(  x_sender2, this ))
, guard121(new AndGuard( new Guard_47_0(  packet ), new OrGuard( new Guard_47_1(  packet ), new Guard_47_2(  snd_o_sender2,  packet ))))
, guard128(new AndGuard( new AndGuard( new Guard_55_0(  packet ), new Guard_55_1(  packet )), new Guard_55_2(  snd_o_sender2,  packet )))
, guard133(new AndGuard( new Guard_61_0(  packet ), new OrGuard( new Guard_61_1(  packet ), new Guard_61_2(  snd_i_sender2,  packet ))))
, guard138(new AndGuard( new AndGuard( new Guard_66_0(  packet ), new Guard_66_1(  packet )), new Guard_66_2(  snd_i_sender2,  packet )))
, guard146(new Guard_78_0(  x_sender2, this ))
, guard147(new Guard_77_0(  x_sender2, this ))
, guard158(new Guard_103_0(  x_channel1, this ))
, guard159(new Guard_102_0(  x_channel1,  prop_channel1, this ))
, guard168(new Guard_123_0(  x_channel1, this ))
, guard169(new Guard_122_0(  x_channel1,  prop_channel1, this ))
{
	setCollector( new CollectVisitor( 3 ) );
	TTDReader read_termtree("/home/pulungan/tools/mobius/MobiusProject/rdt/Atomic/rdt4_0/rdt4_0.ttd", this, term_tree, con );

	con[2]->setAssigner( 0, new Assign_125_0(  pcto1,  pctc1,  pcts1,  pctl1 ) );
	con[9]->setAssigner( 0, new Assign_1_0(  snd_o_sender1,  snd_i_sender1 ) );
	con[19]->setAssigner( 0, new Assign_11_0(  packet,  pa_sender1 ) );
	con[27]->setAssigner( 0, new Assign_21_0(  snd_i_sender1,  packet,  pa_sender1 ) );
	con[36]->setAssigner( 0, new Assign_32_0(  pd_sender1,  snd_o_sender1,  packet ) );
	con[39]->setAssigner( 0, new Assign_35_0(  x_sender1, this ) );
	con[48]->setAssigner( 0, new Assign_45_0(  pd_sender1,  packet ) );
	con[51]->setAssigner( 0, new Assign_49_0(  x_sender1, this ) );
	con[55]->setAssigner( 0, new Assign_53_0(  snd_o_sender1 ) );
	con[60]->setAssigner( 0, new Assign_59_0(  packet,  pa_sender1 ) );
	con[68]->setAssigner( 0, new Assign_69_0(  snd_i_sender1,  packet,  pa_sender1 ) );
	con[74]->setAssigner( 0, new Assign_75_0(  pd_sender1,  packet ) );
	con[77]->setAssigner( 0, new Assign_80_0(  x_sender1, this ) );
	con[83]->setAssigner( 0, new Assign_1_0(  snd_o_sender2,  snd_i_sender2 ) );
	con[93]->setAssigner( 0, new Assign_11_0(  packet,  pa_sender2 ) );
	con[101]->setAssigner( 0, new Assign_21_0(  snd_i_sender2,  packet,  pa_sender2 ) );
	con[110]->setAssigner( 0, new Assign_32_0(  pd_sender2,  snd_o_sender2,  packet ) );
	con[113]->setAssigner( 0, new Assign_35_0(  x_sender2, this ) );
	con[122]->setAssigner( 0, new Assign_45_0(  pd_sender2,  packet ) );
	con[125]->setAssigner( 0, new Assign_49_0(  x_sender2, this ) );
	con[129]->setAssigner( 0, new Assign_53_0(  snd_o_sender2 ) );
	con[134]->setAssigner( 0, new Assign_59_0(  packet,  pa_sender2 ) );
	con[142]->setAssigner( 0, new Assign_69_0(  snd_i_sender2,  packet,  pa_sender2 ) );
	con[148]->setAssigner( 0, new Assign_75_0(  pd_sender2,  packet ) );
	con[151]->setAssigner( 0, new Assign_80_0(  x_sender2, this ) );
	con[156]->setAssigner( 0, new Assign_85_0(  x_channel1,  prop_channel1, this ) );
	con[160]->setAssigner( 0, new Assign_93_0(  pcto1 ) );
	con[160]->setAssigner( 1, new Assign_93_1(  pctc1,  packet ) );
	con[160]->setAssigner( 2, new Assign_93_2(  pcts1,  packet ) );
	con[160]->setAssigner( 3, new Assign_93_3(  pctl1 ) );
	con[166]->setAssigner( 0, new Assign_105_0(  x_channel1,  prop_channel1, this ) );
	con[170]->setAssigner( 1, new Assign_113_1(  packet ) );
	con[170]->setAssigner( 2, new Assign_113_2(  packet ) );

	// Link guards/assignments to constructs
	extract_139->setGuard( guard138 );
	extract_24->setGuard( guard23 );
	extract_65->setGuard( guard64 );
	extract_98->setGuard( guard97 );
	rdt_rcv_118->setGuard( guard117 );
	rdt_rcv_1_171->setGuard( new AndGuard( guard168, guard169 ));
	rdt_rcv_1_172->setGuard( new AndGuard( guard168, guard169 ));
	rdt_rcv_1_173->setGuard( new AndGuard( guard168, guard169 ));
	rdt_rcv_2_161->setGuard( new AndGuard( guard158, guard159 ));
	rdt_rcv_2_162->setGuard( new AndGuard( guard158, guard159 ));
	rdt_rcv_2_163->setGuard( new AndGuard( guard158, guard159 ));
	rdt_rcv_44->setGuard( guard43 );
	tau_105->setGuard( guard104 );
	tau_122->setGuard( guard121 );
	tau_129->setGuard( guard128 );
	tau_134->setGuard( guard133 );
	tau_148->setGuard( new AndGuard( guard146, guard147 ));
	tau_160->setGuard( new AndGuard( guard158, guard159 ));
	tau_164->setGuard( new AndGuard( guard158, guard159 ));
	tau_170->setGuard( new AndGuard( guard168, guard169 ));
	tau_174->setGuard( new AndGuard( guard168, guard169 ));
	tau_19->setGuard( guard18 );
	tau_31->setGuard( guard30 );
	tau_48->setGuard( guard47 );
	tau_55->setGuard( guard54 );
	tau_60->setGuard( guard59 );
	tau_74->setGuard( new AndGuard( guard72, guard73 ));
	tau_93->setGuard( guard92 );

	// Link the actions to the termtree
	break_34->setConstruct( con[34] );
	break_57->setConstruct( con[57] );
	break_108->setConstruct( con[108] );
	break_131->setConstruct( con[131] );
	rdt_rcv_15->setConstruct( con[15] );
	rdt_rcv_1_171->setConstruct( con[171] );
	rdt_rcv_15->setConstruct( con[15] );
	rdt_rcv_1_172->setConstruct( con[172] );
	rdt_rcv_15->setConstruct( con[15] );
	rdt_rcv_1_173->setConstruct( con[173] );
	rdt_rcv_44->setConstruct( con[44] );
	rdt_rcv_1_171->setConstruct( con[171] );
	rdt_rcv_44->setConstruct( con[44] );
	rdt_rcv_1_172->setConstruct( con[172] );
	rdt_rcv_44->setConstruct( con[44] );
	rdt_rcv_1_173->setConstruct( con[173] );
	rdt_rcv_89->setConstruct( con[89] );
	rdt_rcv_2_161->setConstruct( con[161] );
	rdt_rcv_89->setConstruct( con[89] );
	rdt_rcv_2_162->setConstruct( con[162] );
	rdt_rcv_89->setConstruct( con[89] );
	rdt_rcv_2_163->setConstruct( con[163] );
	rdt_rcv_118->setConstruct( con[118] );
	rdt_rcv_2_161->setConstruct( con[161] );
	rdt_rcv_118->setConstruct( con[118] );
	rdt_rcv_2_162->setConstruct( con[162] );
	rdt_rcv_118->setConstruct( con[118] );
	rdt_rcv_2_163->setConstruct( con[163] );
	tau_2->setConstruct( con[2] );
	tau_160->setConstruct( con[160] );
	tau_164->setConstruct( con[164] );
	tau_170->setConstruct( con[170] );
	tau_174->setConstruct( con[174] );
	compute_checksum_26->setConstruct( con[26] );
	compute_checksum_35->setConstruct( con[35] );
	compute_checksum_67->setConstruct( con[67] );
	deliver_data_25->setConstruct( con[25] );
	deliver_data_66->setConstruct( con[66] );
	extract_24->setConstruct( con[24] );
	extract_65->setConstruct( con[65] );
	make_pkt_27->setConstruct( con[27] );
	make_pkt_36->setConstruct( con[36] );
	make_pkt_68->setConstruct( con[68] );
	rdt_send_33->setConstruct( con[33] );
	start_timer_39->setConstruct( con[39] );
	start_timer_51->setConstruct( con[51] );
	start_timer_77->setConstruct( con[77] );
	tau_9->setConstruct( con[9] );
	tau_19->setConstruct( con[19] );
	tau_31->setConstruct( con[31] );
	tau_48->setConstruct( con[48] );
	tau_55->setConstruct( con[55] );
	tau_60->setConstruct( con[60] );
	tau_74->setConstruct( con[74] );
	compute_checksum_100->setConstruct( con[100] );
	compute_checksum_109->setConstruct( con[109] );
	compute_checksum_141->setConstruct( con[141] );
	deliver_data_99->setConstruct( con[99] );
	deliver_data_140->setConstruct( con[140] );
	extract_98->setConstruct( con[98] );
	extract_139->setConstruct( con[139] );
	make_pkt_101->setConstruct( con[101] );
	make_pkt_110->setConstruct( con[110] );
	make_pkt_142->setConstruct( con[142] );
	rdt_send_107->setConstruct( con[107] );
	start_timer_113->setConstruct( con[113] );
	start_timer_125->setConstruct( con[125] );
	start_timer_151->setConstruct( con[151] );
	tau_83->setConstruct( con[83] );
	tau_93->setConstruct( con[93] );
	tau_105->setConstruct( con[105] );
	tau_122->setConstruct( con[122] );
	tau_129->setConstruct( con[129] );
	tau_134->setConstruct( con[134] );
	tau_148->setConstruct( con[148] );
	udt_send_21->setConstruct( con[21] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_29->setConstruct( con[29] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_38->setConstruct( con[38] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_50->setConstruct( con[50] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_62->setConstruct( con[62] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_70->setConstruct( con[70] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_76->setConstruct( con[76] );
	udt_send_1_156->setConstruct( con[156] );
	udt_send_95->setConstruct( con[95] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_103->setConstruct( con[103] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_112->setConstruct( con[112] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_124->setConstruct( con[124] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_136->setConstruct( con[136] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_144->setConstruct( con[144] );
	udt_send_2_166->setConstruct( con[166] );
	udt_send_150->setConstruct( con[150] );
	udt_send_2_166->setConstruct( con[166] );

	// Set up dependency information
	bit12.appendEnabledAction( break_34 );
	break_34->addEnablingSV( &bit12 );
	bit2.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit2 );
	bit3.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit3 );
	bit4.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit4 );
	bit5.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit5 );
	bit6.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit6 );
	bit7.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit7 );
	bit8.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit8 );
	bit9.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit9 );
	bit10.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit10 );
	bit11.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit11 );
	bit12.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit12 );
	bit13.appendAffectingAction( break_34 );
	break_34->addAffectedSV( &bit13 );
	bit22.appendEnabledAction( break_57 );
	break_57->addEnablingSV( &bit22 );
	bit2.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit2 );
	bit11.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit11 );
	bit17.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit17 );
	bit18.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit18 );
	bit19.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit19 );
	bit20.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit20 );
	bit21.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit21 );
	bit22.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit22 );
	bit23.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit23 );
	bit24.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit24 );
	bit25.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit25 );
	bit26.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit26 );
	bit27.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit27 );
	bit28.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit28 );
	bit29.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit29 );
	bit30.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit30 );
	bit31.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit31 );
	bit32.appendAffectingAction( break_57 );
	break_57->addAffectedSV( &bit32 );
	bit44.appendEnabledAction( break_108 );
	break_108->addEnablingSV( &bit44 );
	bit34.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit34 );
	bit35.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit35 );
	bit36.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit36 );
	bit37.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit37 );
	bit38.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit38 );
	bit39.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit39 );
	bit40.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit40 );
	bit41.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit41 );
	bit42.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit42 );
	bit43.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit43 );
	bit44.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit44 );
	bit45.appendAffectingAction( break_108 );
	break_108->addAffectedSV( &bit45 );
	bit54.appendEnabledAction( break_131 );
	break_131->addEnablingSV( &bit54 );
	bit34.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit34 );
	bit43.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit43 );
	bit49.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit49 );
	bit50.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit50 );
	bit51.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit51 );
	bit52.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit52 );
	bit53.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit53 );
	bit54.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit54 );
	bit55.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit55 );
	bit56.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit56 );
	bit57.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit57 );
	bit58.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit58 );
	bit59.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit59 );
	bit60.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit60 );
	bit61.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit61 );
	bit62.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit62 );
	bit63.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit63 );
	bit64.appendAffectingAction( break_131 );
	break_131->addAffectedSV( &bit64 );
	bit2.appendEnabledAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addEnablingSV( &bit2 );
	bit3.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit3 );
	bit5.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit5 );
	bit10.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit10 );
	bit73.appendEnabledAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addEnablingSV( &bit73 );
	rdt_rcv_1Sync0->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync0 );
	bit65.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync0 );
	rdt_rcv_1Sync0->addAffectedSV( &bit76 );
	bit2.appendEnabledAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addEnablingSV( &bit2 );
	bit3.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit3 );
	bit5.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit5 );
	bit10.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit10 );
	bit74.appendEnabledAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addEnablingSV( &bit74 );
	rdt_rcv_1Sync1->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync1 );
	bit65.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync1 );
	rdt_rcv_1Sync1->addAffectedSV( &bit76 );
	bit2.appendEnabledAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addEnablingSV( &bit2 );
	bit3.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit3 );
	bit5.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit5 );
	bit10.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit10 );
	bit75.appendEnabledAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addEnablingSV( &bit75 );
	rdt_rcv_1Sync2->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync2 );
	bit65.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync2 );
	rdt_rcv_1Sync2->addAffectedSV( &bit76 );
	bit17.appendEnabledAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addEnablingSV( &bit17 );
	rdt_rcv_1Sync3->addEnablingSV( x_sender1 );
	x_sender1->appendEnabledAction( rdt_rcv_1Sync3 );
	bit18.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit18 );
	bit21.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit21 );
	bit23.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit23 );
	bit25.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit25 );
	bit73.appendEnabledAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addEnablingSV( &bit73 );
	rdt_rcv_1Sync3->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync3 );
	bit65.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync3 );
	rdt_rcv_1Sync3->addAffectedSV( &bit76 );
	bit17.appendEnabledAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addEnablingSV( &bit17 );
	rdt_rcv_1Sync4->addEnablingSV( x_sender1 );
	x_sender1->appendEnabledAction( rdt_rcv_1Sync4 );
	bit18.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit18 );
	bit21.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit21 );
	bit23.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit23 );
	bit25.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit25 );
	bit74.appendEnabledAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addEnablingSV( &bit74 );
	rdt_rcv_1Sync4->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync4 );
	bit65.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync4 );
	rdt_rcv_1Sync4->addAffectedSV( &bit76 );
	bit17.appendEnabledAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addEnablingSV( &bit17 );
	rdt_rcv_1Sync5->addEnablingSV( x_sender1 );
	x_sender1->appendEnabledAction( rdt_rcv_1Sync5 );
	bit18.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit18 );
	bit21.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit21 );
	bit23.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit23 );
	bit25.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit25 );
	bit75.appendEnabledAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addEnablingSV( &bit75 );
	rdt_rcv_1Sync5->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_1Sync5 );
	bit65.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( rdt_rcv_1Sync5 );
	rdt_rcv_1Sync5->addAffectedSV( &bit76 );
	bit34.appendEnabledAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addEnablingSV( &bit34 );
	bit35.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit35 );
	bit37.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit37 );
	bit42.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit42 );
	bit67.appendEnabledAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addEnablingSV( &bit67 );
	rdt_rcv_2Sync6->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync6 );
	bit65.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync6 );
	rdt_rcv_2Sync6->addAffectedSV( &bit71 );
	bit34.appendEnabledAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addEnablingSV( &bit34 );
	bit35.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit35 );
	bit37.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit37 );
	bit42.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit42 );
	bit68.appendEnabledAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addEnablingSV( &bit68 );
	rdt_rcv_2Sync7->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync7 );
	bit65.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync7 );
	rdt_rcv_2Sync7->addAffectedSV( &bit71 );
	bit34.appendEnabledAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addEnablingSV( &bit34 );
	bit35.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit35 );
	bit37.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit37 );
	bit42.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit42 );
	bit69.appendEnabledAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addEnablingSV( &bit69 );
	rdt_rcv_2Sync8->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync8 );
	bit65.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync8 );
	rdt_rcv_2Sync8->addAffectedSV( &bit71 );
	bit49.appendEnabledAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addEnablingSV( &bit49 );
	rdt_rcv_2Sync9->addEnablingSV( x_sender2 );
	x_sender2->appendEnabledAction( rdt_rcv_2Sync9 );
	bit50.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit50 );
	bit53.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit53 );
	bit55.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit55 );
	bit57.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit57 );
	bit67.appendEnabledAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addEnablingSV( &bit67 );
	rdt_rcv_2Sync9->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync9 );
	bit65.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync9 );
	rdt_rcv_2Sync9->addAffectedSV( &bit71 );
	bit49.appendEnabledAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addEnablingSV( &bit49 );
	rdt_rcv_2Sync10->addEnablingSV( x_sender2 );
	x_sender2->appendEnabledAction( rdt_rcv_2Sync10 );
	bit50.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit50 );
	bit53.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit53 );
	bit55.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit55 );
	bit57.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit57 );
	bit68.appendEnabledAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addEnablingSV( &bit68 );
	rdt_rcv_2Sync10->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync10 );
	bit65.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync10 );
	rdt_rcv_2Sync10->addAffectedSV( &bit71 );
	bit49.appendEnabledAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addEnablingSV( &bit49 );
	rdt_rcv_2Sync11->addEnablingSV( x_sender2 );
	x_sender2->appendEnabledAction( rdt_rcv_2Sync11 );
	bit50.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit50 );
	bit53.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit53 );
	bit55.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit55 );
	bit57.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit57 );
	bit69.appendEnabledAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addEnablingSV( &bit69 );
	rdt_rcv_2Sync11->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( rdt_rcv_2Sync11 );
	bit65.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( rdt_rcv_2Sync11 );
	rdt_rcv_2Sync11->addAffectedSV( &bit71 );
	bit0.appendEnabledAction( tau_2 );
	tau_2->addEnablingSV( &bit0 );
	tau_2->addAffectedSV( pctc1 );
	pctc1->appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( pctl1 );
	pctl1->appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( pcto1 );
	pcto1->appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( pcts1 );
	pcts1->appendAffectingAction( tau_2 );
	bit1.appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( &bit1 );
	bit33.appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( &bit33 );
	bit65.appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( tau_2 );
	tau_2->addAffectedSV( &bit71 );
	bit66.appendEnabledAction( tau_160 );
	tau_160->addEnablingSV( &bit66 );
	tau_160->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( tau_160 );
	tau_160->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( tau_160 );
	tau_160->addAffectedSV( packet );
	packet->appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( pctc1 );
	pctc1->appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( pctl1 );
	pctl1->appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( pcto1 );
	pcto1->appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( pcts1 );
	pcts1->appendAffectingAction( tau_160 );
	bit65.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( tau_160 );
	tau_160->addAffectedSV( &bit71 );
	bit70.appendEnabledAction( tau_164 );
	tau_164->addEnablingSV( &bit70 );
	tau_164->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( tau_164 );
	tau_164->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( tau_164 );
	bit65.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit65 );
	bit67.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit67 );
	bit68.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit68 );
	bit69.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit69 );
	bit70.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit70 );
	bit71.appendAffectingAction( tau_164 );
	tau_164->addAffectedSV( &bit71 );
	bit72.appendEnabledAction( tau_170 );
	tau_170->addEnablingSV( &bit72 );
	tau_170->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( tau_170 );
	tau_170->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( tau_170 );
	tau_170->addAffectedSV( packet );
	packet->appendAffectingAction( tau_170 );
	bit65.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( tau_170 );
	tau_170->addAffectedSV( &bit76 );
	bit76.appendEnabledAction( tau_174 );
	tau_174->addEnablingSV( &bit76 );
	tau_174->addEnablingSV( prop_channel1 );
	prop_channel1->appendEnabledAction( tau_174 );
	tau_174->addEnablingSV( x_channel1 );
	x_channel1->appendEnabledAction( tau_174 );
	bit65.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit65 );
	bit71.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit71 );
	bit73.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit73 );
	bit74.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit74 );
	bit75.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit75 );
	bit76.appendAffectingAction( tau_174 );
	tau_174->addAffectedSV( &bit76 );
	bit7.appendEnabledAction( compute_checksum_26 );
	compute_checksum_26->addEnablingSV( &bit7 );
	bit8.appendAffectingAction( compute_checksum_26 );
	compute_checksum_26->addAffectedSV( &bit8 );
	bit13.appendEnabledAction( compute_checksum_35 );
	compute_checksum_35->addEnablingSV( &bit13 );
	bit14.appendAffectingAction( compute_checksum_35 );
	compute_checksum_35->addAffectedSV( &bit14 );
	bit27.appendEnabledAction( compute_checksum_67 );
	compute_checksum_67->addEnablingSV( &bit27 );
	bit28.appendAffectingAction( compute_checksum_67 );
	compute_checksum_67->addAffectedSV( &bit28 );
	bit6.appendEnabledAction( deliver_data_25 );
	deliver_data_25->addEnablingSV( &bit6 );
	bit7.appendAffectingAction( deliver_data_25 );
	deliver_data_25->addAffectedSV( &bit7 );
	bit26.appendEnabledAction( deliver_data_66 );
	deliver_data_66->addEnablingSV( &bit26 );
	bit27.appendAffectingAction( deliver_data_66 );
	deliver_data_66->addAffectedSV( &bit27 );
	bit5.appendEnabledAction( extract_24 );
	extract_24->addEnablingSV( &bit5 );
	extract_24->addEnablingSV( packet );
	packet->appendEnabledAction( extract_24 );
	extract_24->addEnablingSV( snd_i_sender1 );
	snd_i_sender1->appendEnabledAction( extract_24 );
	bit6.appendAffectingAction( extract_24 );
	extract_24->addAffectedSV( &bit6 );
	bit25.appendEnabledAction( extract_65 );
	extract_65->addEnablingSV( &bit25 );
	extract_65->addEnablingSV( packet );
	packet->appendEnabledAction( extract_65 );
	extract_65->addEnablingSV( snd_i_sender1 );
	snd_i_sender1->appendEnabledAction( extract_65 );
	bit26.appendAffectingAction( extract_65 );
	extract_65->addAffectedSV( &bit26 );
	bit8.appendEnabledAction( make_pkt_27 );
	make_pkt_27->addEnablingSV( &bit8 );
	make_pkt_27->addAffectedSV( pa_sender1 );
	pa_sender1->appendAffectingAction( make_pkt_27 );
	make_pkt_27->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_27 );
	make_pkt_27->addAffectedSV( snd_i_sender1 );
	snd_i_sender1->appendAffectingAction( make_pkt_27 );
	bit9.appendAffectingAction( make_pkt_27 );
	make_pkt_27->addAffectedSV( &bit9 );
	bit14.appendEnabledAction( make_pkt_36 );
	make_pkt_36->addEnablingSV( &bit14 );
	make_pkt_36->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_36 );
	make_pkt_36->addAffectedSV( pd_sender1 );
	pd_sender1->appendAffectingAction( make_pkt_36 );
	make_pkt_36->addAffectedSV( snd_o_sender1 );
	snd_o_sender1->appendAffectingAction( make_pkt_36 );
	bit15.appendAffectingAction( make_pkt_36 );
	make_pkt_36->addAffectedSV( &bit15 );
	bit28.appendEnabledAction( make_pkt_68 );
	make_pkt_68->addEnablingSV( &bit28 );
	make_pkt_68->addAffectedSV( pa_sender1 );
	pa_sender1->appendAffectingAction( make_pkt_68 );
	make_pkt_68->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_68 );
	make_pkt_68->addAffectedSV( snd_i_sender1 );
	snd_i_sender1->appendAffectingAction( make_pkt_68 );
	bit29.appendAffectingAction( make_pkt_68 );
	make_pkt_68->addAffectedSV( &bit29 );
	bit11.appendEnabledAction( rdt_send_33 );
	rdt_send_33->addEnablingSV( &bit11 );
	bit12.appendAffectingAction( rdt_send_33 );
	rdt_send_33->addAffectedSV( &bit12 );
	bit16.appendEnabledAction( start_timer_39 );
	start_timer_39->addEnablingSV( &bit16 );
	start_timer_39->addAffectedSV( x_sender1 );
	x_sender1->appendAffectingAction( start_timer_39 );
	bit17.appendAffectingAction( start_timer_39 );
	start_timer_39->addAffectedSV( &bit17 );
	bit30.appendAffectingAction( start_timer_39 );
	start_timer_39->addAffectedSV( &bit30 );
	bit20.appendEnabledAction( start_timer_51 );
	start_timer_51->addEnablingSV( &bit20 );
	start_timer_51->addAffectedSV( x_sender1 );
	x_sender1->appendAffectingAction( start_timer_51 );
	bit17.appendAffectingAction( start_timer_51 );
	start_timer_51->addAffectedSV( &bit17 );
	bit30.appendAffectingAction( start_timer_51 );
	start_timer_51->addAffectedSV( &bit30 );
	bit32.appendEnabledAction( start_timer_77 );
	start_timer_77->addEnablingSV( &bit32 );
	start_timer_77->addAffectedSV( x_sender1 );
	x_sender1->appendAffectingAction( start_timer_77 );
	bit17.appendAffectingAction( start_timer_77 );
	start_timer_77->addAffectedSV( &bit17 );
	bit30.appendAffectingAction( start_timer_77 );
	start_timer_77->addAffectedSV( &bit30 );
	bit1.appendEnabledAction( tau_9 );
	tau_9->addEnablingSV( &bit1 );
	tau_9->addAffectedSV( snd_i_sender1 );
	snd_i_sender1->appendAffectingAction( tau_9 );
	tau_9->addAffectedSV( snd_o_sender1 );
	snd_o_sender1->appendAffectingAction( tau_9 );
	bit2.appendAffectingAction( tau_9 );
	tau_9->addAffectedSV( &bit2 );
	bit11.appendAffectingAction( tau_9 );
	tau_9->addAffectedSV( &bit11 );
	bit3.appendEnabledAction( tau_19 );
	tau_19->addEnablingSV( &bit3 );
	tau_19->addEnablingSV( packet );
	packet->appendEnabledAction( tau_19 );
	tau_19->addEnablingSV( snd_i_sender1 );
	snd_i_sender1->appendEnabledAction( tau_19 );
	tau_19->addAffectedSV( pa_sender1 );
	pa_sender1->appendAffectingAction( tau_19 );
	tau_19->addAffectedSV( packet );
	packet->appendAffectingAction( tau_19 );
	bit4.appendAffectingAction( tau_19 );
	tau_19->addAffectedSV( &bit4 );
	bit10.appendEnabledAction( tau_31 );
	tau_31->addEnablingSV( &bit10 );
	tau_31->addEnablingSV( packet );
	packet->appendEnabledAction( tau_31 );
	bit2.appendAffectingAction( tau_31 );
	tau_31->addAffectedSV( &bit2 );
	bit11.appendAffectingAction( tau_31 );
	tau_31->addAffectedSV( &bit11 );
	bit18.appendEnabledAction( tau_48 );
	tau_48->addEnablingSV( &bit18 );
	tau_48->addEnablingSV( packet );
	packet->appendEnabledAction( tau_48 );
	tau_48->addEnablingSV( snd_o_sender1 );
	snd_o_sender1->appendEnabledAction( tau_48 );
	tau_48->addAffectedSV( packet );
	packet->appendAffectingAction( tau_48 );
	tau_48->addAffectedSV( pd_sender1 );
	pd_sender1->appendAffectingAction( tau_48 );
	bit19.appendAffectingAction( tau_48 );
	tau_48->addAffectedSV( &bit19 );
	bit21.appendEnabledAction( tau_55 );
	tau_55->addEnablingSV( &bit21 );
	tau_55->addEnablingSV( packet );
	packet->appendEnabledAction( tau_55 );
	tau_55->addEnablingSV( snd_o_sender1 );
	snd_o_sender1->appendEnabledAction( tau_55 );
	tau_55->addAffectedSV( snd_o_sender1 );
	snd_o_sender1->appendAffectingAction( tau_55 );
	bit22.appendAffectingAction( tau_55 );
	tau_55->addAffectedSV( &bit22 );
	bit23.appendEnabledAction( tau_60 );
	tau_60->addEnablingSV( &bit23 );
	tau_60->addEnablingSV( packet );
	packet->appendEnabledAction( tau_60 );
	tau_60->addEnablingSV( snd_i_sender1 );
	snd_i_sender1->appendEnabledAction( tau_60 );
	tau_60->addAffectedSV( pa_sender1 );
	pa_sender1->appendAffectingAction( tau_60 );
	tau_60->addAffectedSV( packet );
	packet->appendAffectingAction( tau_60 );
	bit24.appendAffectingAction( tau_60 );
	tau_60->addAffectedSV( &bit24 );
	bit30.appendEnabledAction( tau_74 );
	tau_74->addEnablingSV( &bit30 );
	tau_74->addEnablingSV( x_sender1 );
	x_sender1->appendEnabledAction( tau_74 );
	tau_74->addAffectedSV( packet );
	packet->appendAffectingAction( tau_74 );
	tau_74->addAffectedSV( pd_sender1 );
	pd_sender1->appendAffectingAction( tau_74 );
	bit31.appendAffectingAction( tau_74 );
	tau_74->addAffectedSV( &bit31 );
	bit39.appendEnabledAction( compute_checksum_100 );
	compute_checksum_100->addEnablingSV( &bit39 );
	bit40.appendAffectingAction( compute_checksum_100 );
	compute_checksum_100->addAffectedSV( &bit40 );
	bit45.appendEnabledAction( compute_checksum_109 );
	compute_checksum_109->addEnablingSV( &bit45 );
	bit46.appendAffectingAction( compute_checksum_109 );
	compute_checksum_109->addAffectedSV( &bit46 );
	bit59.appendEnabledAction( compute_checksum_141 );
	compute_checksum_141->addEnablingSV( &bit59 );
	bit60.appendAffectingAction( compute_checksum_141 );
	compute_checksum_141->addAffectedSV( &bit60 );
	bit38.appendEnabledAction( deliver_data_99 );
	deliver_data_99->addEnablingSV( &bit38 );
	bit39.appendAffectingAction( deliver_data_99 );
	deliver_data_99->addAffectedSV( &bit39 );
	bit58.appendEnabledAction( deliver_data_140 );
	deliver_data_140->addEnablingSV( &bit58 );
	bit59.appendAffectingAction( deliver_data_140 );
	deliver_data_140->addAffectedSV( &bit59 );
	bit37.appendEnabledAction( extract_98 );
	extract_98->addEnablingSV( &bit37 );
	extract_98->addEnablingSV( packet );
	packet->appendEnabledAction( extract_98 );
	extract_98->addEnablingSV( snd_i_sender2 );
	snd_i_sender2->appendEnabledAction( extract_98 );
	bit38.appendAffectingAction( extract_98 );
	extract_98->addAffectedSV( &bit38 );
	bit57.appendEnabledAction( extract_139 );
	extract_139->addEnablingSV( &bit57 );
	extract_139->addEnablingSV( packet );
	packet->appendEnabledAction( extract_139 );
	extract_139->addEnablingSV( snd_i_sender2 );
	snd_i_sender2->appendEnabledAction( extract_139 );
	bit58.appendAffectingAction( extract_139 );
	extract_139->addAffectedSV( &bit58 );
	bit40.appendEnabledAction( make_pkt_101 );
	make_pkt_101->addEnablingSV( &bit40 );
	make_pkt_101->addAffectedSV( pa_sender2 );
	pa_sender2->appendAffectingAction( make_pkt_101 );
	make_pkt_101->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_101 );
	make_pkt_101->addAffectedSV( snd_i_sender2 );
	snd_i_sender2->appendAffectingAction( make_pkt_101 );
	bit41.appendAffectingAction( make_pkt_101 );
	make_pkt_101->addAffectedSV( &bit41 );
	bit46.appendEnabledAction( make_pkt_110 );
	make_pkt_110->addEnablingSV( &bit46 );
	make_pkt_110->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_110 );
	make_pkt_110->addAffectedSV( pd_sender2 );
	pd_sender2->appendAffectingAction( make_pkt_110 );
	make_pkt_110->addAffectedSV( snd_o_sender2 );
	snd_o_sender2->appendAffectingAction( make_pkt_110 );
	bit47.appendAffectingAction( make_pkt_110 );
	make_pkt_110->addAffectedSV( &bit47 );
	bit60.appendEnabledAction( make_pkt_142 );
	make_pkt_142->addEnablingSV( &bit60 );
	make_pkt_142->addAffectedSV( pa_sender2 );
	pa_sender2->appendAffectingAction( make_pkt_142 );
	make_pkt_142->addAffectedSV( packet );
	packet->appendAffectingAction( make_pkt_142 );
	make_pkt_142->addAffectedSV( snd_i_sender2 );
	snd_i_sender2->appendAffectingAction( make_pkt_142 );
	bit61.appendAffectingAction( make_pkt_142 );
	make_pkt_142->addAffectedSV( &bit61 );
	bit43.appendEnabledAction( rdt_send_107 );
	rdt_send_107->addEnablingSV( &bit43 );
	bit44.appendAffectingAction( rdt_send_107 );
	rdt_send_107->addAffectedSV( &bit44 );
	bit48.appendEnabledAction( start_timer_113 );
	start_timer_113->addEnablingSV( &bit48 );
	start_timer_113->addAffectedSV( x_sender2 );
	x_sender2->appendAffectingAction( start_timer_113 );
	bit49.appendAffectingAction( start_timer_113 );
	start_timer_113->addAffectedSV( &bit49 );
	bit62.appendAffectingAction( start_timer_113 );
	start_timer_113->addAffectedSV( &bit62 );
	bit52.appendEnabledAction( start_timer_125 );
	start_timer_125->addEnablingSV( &bit52 );
	start_timer_125->addAffectedSV( x_sender2 );
	x_sender2->appendAffectingAction( start_timer_125 );
	bit49.appendAffectingAction( start_timer_125 );
	start_timer_125->addAffectedSV( &bit49 );
	bit62.appendAffectingAction( start_timer_125 );
	start_timer_125->addAffectedSV( &bit62 );
	bit64.appendEnabledAction( start_timer_151 );
	start_timer_151->addEnablingSV( &bit64 );
	start_timer_151->addAffectedSV( x_sender2 );
	x_sender2->appendAffectingAction( start_timer_151 );
	bit49.appendAffectingAction( start_timer_151 );
	start_timer_151->addAffectedSV( &bit49 );
	bit62.appendAffectingAction( start_timer_151 );
	start_timer_151->addAffectedSV( &bit62 );
	bit33.appendEnabledAction( tau_83 );
	tau_83->addEnablingSV( &bit33 );
	tau_83->addAffectedSV( snd_i_sender2 );
	snd_i_sender2->appendAffectingAction( tau_83 );
	tau_83->addAffectedSV( snd_o_sender2 );
	snd_o_sender2->appendAffectingAction( tau_83 );
	bit34.appendAffectingAction( tau_83 );
	tau_83->addAffectedSV( &bit34 );
	bit43.appendAffectingAction( tau_83 );
	tau_83->addAffectedSV( &bit43 );
	bit35.appendEnabledAction( tau_93 );
	tau_93->addEnablingSV( &bit35 );
	tau_93->addEnablingSV( packet );
	packet->appendEnabledAction( tau_93 );
	tau_93->addEnablingSV( snd_i_sender2 );
	snd_i_sender2->appendEnabledAction( tau_93 );
	tau_93->addAffectedSV( pa_sender2 );
	pa_sender2->appendAffectingAction( tau_93 );
	tau_93->addAffectedSV( packet );
	packet->appendAffectingAction( tau_93 );
	bit36.appendAffectingAction( tau_93 );
	tau_93->addAffectedSV( &bit36 );
	bit42.appendEnabledAction( tau_105 );
	tau_105->addEnablingSV( &bit42 );
	tau_105->addEnablingSV( packet );
	packet->appendEnabledAction( tau_105 );
	bit34.appendAffectingAction( tau_105 );
	tau_105->addAffectedSV( &bit34 );
	bit43.appendAffectingAction( tau_105 );
	tau_105->addAffectedSV( &bit43 );
	bit50.appendEnabledAction( tau_122 );
	tau_122->addEnablingSV( &bit50 );
	tau_122->addEnablingSV( packet );
	packet->appendEnabledAction( tau_122 );
	tau_122->addEnablingSV( snd_o_sender2 );
	snd_o_sender2->appendEnabledAction( tau_122 );
	tau_122->addAffectedSV( packet );
	packet->appendAffectingAction( tau_122 );
	tau_122->addAffectedSV( pd_sender2 );
	pd_sender2->appendAffectingAction( tau_122 );
	bit51.appendAffectingAction( tau_122 );
	tau_122->addAffectedSV( &bit51 );
	bit53.appendEnabledAction( tau_129 );
	tau_129->addEnablingSV( &bit53 );
	tau_129->addEnablingSV( packet );
	packet->appendEnabledAction( tau_129 );
	tau_129->addEnablingSV( snd_o_sender2 );
	snd_o_sender2->appendEnabledAction( tau_129 );
	tau_129->addAffectedSV( snd_o_sender2 );
	snd_o_sender2->appendAffectingAction( tau_129 );
	bit54.appendAffectingAction( tau_129 );
	tau_129->addAffectedSV( &bit54 );
	bit55.appendEnabledAction( tau_134 );
	tau_134->addEnablingSV( &bit55 );
	tau_134->addEnablingSV( packet );
	packet->appendEnabledAction( tau_134 );
	tau_134->addEnablingSV( snd_i_sender2 );
	snd_i_sender2->appendEnabledAction( tau_134 );
	tau_134->addAffectedSV( pa_sender2 );
	pa_sender2->appendAffectingAction( tau_134 );
	tau_134->addAffectedSV( packet );
	packet->appendAffectingAction( tau_134 );
	bit56.appendAffectingAction( tau_134 );
	tau_134->addAffectedSV( &bit56 );
	bit62.appendEnabledAction( tau_148 );
	tau_148->addEnablingSV( &bit62 );
	tau_148->addEnablingSV( x_sender2 );
	x_sender2->appendEnabledAction( tau_148 );
	tau_148->addAffectedSV( packet );
	packet->appendAffectingAction( tau_148 );
	tau_148->addAffectedSV( pd_sender2 );
	pd_sender2->appendAffectingAction( tau_148 );
	bit63.appendAffectingAction( tau_148 );
	tau_148->addAffectedSV( &bit63 );
	bit4.appendEnabledAction( udt_send_1Sync12 );
	udt_send_1Sync12->addEnablingSV( &bit4 );
	bit2.appendAffectingAction( udt_send_1Sync12 );
	udt_send_1Sync12->addAffectedSV( &bit2 );
	bit11.appendAffectingAction( udt_send_1Sync12 );
	udt_send_1Sync12->addAffectedSV( &bit11 );
	bit65.appendEnabledAction( udt_send_1Sync12 );
	udt_send_1Sync12->addEnablingSV( &bit65 );
	udt_send_1Sync12->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync12 );
	udt_send_1Sync12->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync12 );
	bit66.appendAffectingAction( udt_send_1Sync12 );
	udt_send_1Sync12->addAffectedSV( &bit66 );
	bit9.appendEnabledAction( udt_send_1Sync13 );
	udt_send_1Sync13->addEnablingSV( &bit9 );
	bit2.appendAffectingAction( udt_send_1Sync13 );
	udt_send_1Sync13->addAffectedSV( &bit2 );
	bit11.appendAffectingAction( udt_send_1Sync13 );
	udt_send_1Sync13->addAffectedSV( &bit11 );
	bit65.appendEnabledAction( udt_send_1Sync13 );
	udt_send_1Sync13->addEnablingSV( &bit65 );
	udt_send_1Sync13->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync13 );
	udt_send_1Sync13->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync13 );
	bit66.appendAffectingAction( udt_send_1Sync13 );
	udt_send_1Sync13->addAffectedSV( &bit66 );
	bit15.appendEnabledAction( udt_send_1Sync14 );
	udt_send_1Sync14->addEnablingSV( &bit15 );
	bit16.appendAffectingAction( udt_send_1Sync14 );
	udt_send_1Sync14->addAffectedSV( &bit16 );
	bit65.appendEnabledAction( udt_send_1Sync14 );
	udt_send_1Sync14->addEnablingSV( &bit65 );
	udt_send_1Sync14->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync14 );
	udt_send_1Sync14->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync14 );
	bit66.appendAffectingAction( udt_send_1Sync14 );
	udt_send_1Sync14->addAffectedSV( &bit66 );
	bit19.appendEnabledAction( udt_send_1Sync15 );
	udt_send_1Sync15->addEnablingSV( &bit19 );
	bit20.appendAffectingAction( udt_send_1Sync15 );
	udt_send_1Sync15->addAffectedSV( &bit20 );
	bit65.appendEnabledAction( udt_send_1Sync15 );
	udt_send_1Sync15->addEnablingSV( &bit65 );
	udt_send_1Sync15->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync15 );
	udt_send_1Sync15->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync15 );
	bit66.appendAffectingAction( udt_send_1Sync15 );
	udt_send_1Sync15->addAffectedSV( &bit66 );
	bit24.appendEnabledAction( udt_send_1Sync16 );
	udt_send_1Sync16->addEnablingSV( &bit24 );
	bit17.appendAffectingAction( udt_send_1Sync16 );
	udt_send_1Sync16->addAffectedSV( &bit17 );
	bit30.appendAffectingAction( udt_send_1Sync16 );
	udt_send_1Sync16->addAffectedSV( &bit30 );
	bit65.appendEnabledAction( udt_send_1Sync16 );
	udt_send_1Sync16->addEnablingSV( &bit65 );
	udt_send_1Sync16->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync16 );
	udt_send_1Sync16->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync16 );
	bit66.appendAffectingAction( udt_send_1Sync16 );
	udt_send_1Sync16->addAffectedSV( &bit66 );
	bit29.appendEnabledAction( udt_send_1Sync17 );
	udt_send_1Sync17->addEnablingSV( &bit29 );
	bit17.appendAffectingAction( udt_send_1Sync17 );
	udt_send_1Sync17->addAffectedSV( &bit17 );
	bit30.appendAffectingAction( udt_send_1Sync17 );
	udt_send_1Sync17->addAffectedSV( &bit30 );
	bit65.appendEnabledAction( udt_send_1Sync17 );
	udt_send_1Sync17->addEnablingSV( &bit65 );
	udt_send_1Sync17->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync17 );
	udt_send_1Sync17->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync17 );
	bit66.appendAffectingAction( udt_send_1Sync17 );
	udt_send_1Sync17->addAffectedSV( &bit66 );
	bit31.appendEnabledAction( udt_send_1Sync18 );
	udt_send_1Sync18->addEnablingSV( &bit31 );
	bit32.appendAffectingAction( udt_send_1Sync18 );
	udt_send_1Sync18->addAffectedSV( &bit32 );
	bit65.appendEnabledAction( udt_send_1Sync18 );
	udt_send_1Sync18->addEnablingSV( &bit65 );
	udt_send_1Sync18->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_1Sync18 );
	udt_send_1Sync18->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_1Sync18 );
	bit66.appendAffectingAction( udt_send_1Sync18 );
	udt_send_1Sync18->addAffectedSV( &bit66 );
	bit36.appendEnabledAction( udt_send_2Sync19 );
	udt_send_2Sync19->addEnablingSV( &bit36 );
	bit34.appendAffectingAction( udt_send_2Sync19 );
	udt_send_2Sync19->addAffectedSV( &bit34 );
	bit43.appendAffectingAction( udt_send_2Sync19 );
	udt_send_2Sync19->addAffectedSV( &bit43 );
	bit71.appendEnabledAction( udt_send_2Sync19 );
	udt_send_2Sync19->addEnablingSV( &bit71 );
	udt_send_2Sync19->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync19 );
	udt_send_2Sync19->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync19 );
	bit72.appendAffectingAction( udt_send_2Sync19 );
	udt_send_2Sync19->addAffectedSV( &bit72 );
	bit41.appendEnabledAction( udt_send_2Sync20 );
	udt_send_2Sync20->addEnablingSV( &bit41 );
	bit34.appendAffectingAction( udt_send_2Sync20 );
	udt_send_2Sync20->addAffectedSV( &bit34 );
	bit43.appendAffectingAction( udt_send_2Sync20 );
	udt_send_2Sync20->addAffectedSV( &bit43 );
	bit71.appendEnabledAction( udt_send_2Sync20 );
	udt_send_2Sync20->addEnablingSV( &bit71 );
	udt_send_2Sync20->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync20 );
	udt_send_2Sync20->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync20 );
	bit72.appendAffectingAction( udt_send_2Sync20 );
	udt_send_2Sync20->addAffectedSV( &bit72 );
	bit47.appendEnabledAction( udt_send_2Sync21 );
	udt_send_2Sync21->addEnablingSV( &bit47 );
	bit48.appendAffectingAction( udt_send_2Sync21 );
	udt_send_2Sync21->addAffectedSV( &bit48 );
	bit71.appendEnabledAction( udt_send_2Sync21 );
	udt_send_2Sync21->addEnablingSV( &bit71 );
	udt_send_2Sync21->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync21 );
	udt_send_2Sync21->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync21 );
	bit72.appendAffectingAction( udt_send_2Sync21 );
	udt_send_2Sync21->addAffectedSV( &bit72 );
	bit51.appendEnabledAction( udt_send_2Sync22 );
	udt_send_2Sync22->addEnablingSV( &bit51 );
	bit52.appendAffectingAction( udt_send_2Sync22 );
	udt_send_2Sync22->addAffectedSV( &bit52 );
	bit71.appendEnabledAction( udt_send_2Sync22 );
	udt_send_2Sync22->addEnablingSV( &bit71 );
	udt_send_2Sync22->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync22 );
	udt_send_2Sync22->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync22 );
	bit72.appendAffectingAction( udt_send_2Sync22 );
	udt_send_2Sync22->addAffectedSV( &bit72 );
	bit56.appendEnabledAction( udt_send_2Sync23 );
	udt_send_2Sync23->addEnablingSV( &bit56 );
	bit49.appendAffectingAction( udt_send_2Sync23 );
	udt_send_2Sync23->addAffectedSV( &bit49 );
	bit62.appendAffectingAction( udt_send_2Sync23 );
	udt_send_2Sync23->addAffectedSV( &bit62 );
	bit71.appendEnabledAction( udt_send_2Sync23 );
	udt_send_2Sync23->addEnablingSV( &bit71 );
	udt_send_2Sync23->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync23 );
	udt_send_2Sync23->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync23 );
	bit72.appendAffectingAction( udt_send_2Sync23 );
	udt_send_2Sync23->addAffectedSV( &bit72 );
	bit61.appendEnabledAction( udt_send_2Sync24 );
	udt_send_2Sync24->addEnablingSV( &bit61 );
	bit49.appendAffectingAction( udt_send_2Sync24 );
	udt_send_2Sync24->addAffectedSV( &bit49 );
	bit62.appendAffectingAction( udt_send_2Sync24 );
	udt_send_2Sync24->addAffectedSV( &bit62 );
	bit71.appendEnabledAction( udt_send_2Sync24 );
	udt_send_2Sync24->addEnablingSV( &bit71 );
	udt_send_2Sync24->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync24 );
	udt_send_2Sync24->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync24 );
	bit72.appendAffectingAction( udt_send_2Sync24 );
	udt_send_2Sync24->addAffectedSV( &bit72 );
	bit63.appendEnabledAction( udt_send_2Sync25 );
	udt_send_2Sync25->addEnablingSV( &bit63 );
	bit64.appendAffectingAction( udt_send_2Sync25 );
	udt_send_2Sync25->addAffectedSV( &bit64 );
	bit71.appendEnabledAction( udt_send_2Sync25 );
	udt_send_2Sync25->addEnablingSV( &bit71 );
	udt_send_2Sync25->addAffectedSV( prop_channel1 );
	prop_channel1->appendAffectingAction( udt_send_2Sync25 );
	udt_send_2Sync25->addAffectedSV( x_channel1 );
	x_channel1->appendAffectingAction( udt_send_2Sync25 );
	bit72.appendAffectingAction( udt_send_2Sync25 );
	udt_send_2Sync25->addAffectedSV( &bit72 );

	// Set up synchronizing actions
	rdt_rcv_1Sync0->addAtomicAction( rdt_rcv_15 );
	rdt_rcv_1Sync0->addAtomicAction( rdt_rcv_1_171 );
	rdt_rcv_1Sync1->addAtomicAction( rdt_rcv_15 );
	rdt_rcv_1Sync1->addAtomicAction( rdt_rcv_1_172 );
	rdt_rcv_1Sync2->addAtomicAction( rdt_rcv_15 );
	rdt_rcv_1Sync2->addAtomicAction( rdt_rcv_1_173 );
	rdt_rcv_1Sync3->addAtomicAction( rdt_rcv_44 );
	rdt_rcv_1Sync3->addAtomicAction( rdt_rcv_1_171 );
	rdt_rcv_1Sync4->addAtomicAction( rdt_rcv_44 );
	rdt_rcv_1Sync4->addAtomicAction( rdt_rcv_1_172 );
	rdt_rcv_1Sync5->addAtomicAction( rdt_rcv_44 );
	rdt_rcv_1Sync5->addAtomicAction( rdt_rcv_1_173 );
	rdt_rcv_2Sync6->addAtomicAction( rdt_rcv_89 );
	rdt_rcv_2Sync6->addAtomicAction( rdt_rcv_2_161 );
	rdt_rcv_2Sync7->addAtomicAction( rdt_rcv_89 );
	rdt_rcv_2Sync7->addAtomicAction( rdt_rcv_2_162 );
	rdt_rcv_2Sync8->addAtomicAction( rdt_rcv_89 );
	rdt_rcv_2Sync8->addAtomicAction( rdt_rcv_2_163 );
	rdt_rcv_2Sync9->addAtomicAction( rdt_rcv_118 );
	rdt_rcv_2Sync9->addAtomicAction( rdt_rcv_2_161 );
	rdt_rcv_2Sync10->addAtomicAction( rdt_rcv_118 );
	rdt_rcv_2Sync10->addAtomicAction( rdt_rcv_2_162 );
	rdt_rcv_2Sync11->addAtomicAction( rdt_rcv_118 );
	rdt_rcv_2Sync11->addAtomicAction( rdt_rcv_2_163 );
	udt_send_1Sync12->addAtomicAction( udt_send_21 );
	udt_send_1Sync12->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync13->addAtomicAction( udt_send_29 );
	udt_send_1Sync13->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync14->addAtomicAction( udt_send_38 );
	udt_send_1Sync14->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync15->addAtomicAction( udt_send_50 );
	udt_send_1Sync15->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync16->addAtomicAction( udt_send_62 );
	udt_send_1Sync16->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync17->addAtomicAction( udt_send_70 );
	udt_send_1Sync17->addAtomicAction( udt_send_1_156 );
	udt_send_1Sync18->addAtomicAction( udt_send_76 );
	udt_send_1Sync18->addAtomicAction( udt_send_1_156 );
	udt_send_2Sync19->addAtomicAction( udt_send_95 );
	udt_send_2Sync19->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync20->addAtomicAction( udt_send_103 );
	udt_send_2Sync20->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync21->addAtomicAction( udt_send_112 );
	udt_send_2Sync21->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync22->addAtomicAction( udt_send_124 );
	udt_send_2Sync22->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync23->addAtomicAction( udt_send_136 );
	udt_send_2Sync23->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync24->addAtomicAction( udt_send_144 );
	udt_send_2Sync24->addAtomicAction( udt_send_2_166 );
	udt_send_2Sync25->addAtomicAction( udt_send_150 );
	udt_send_2Sync25->addAtomicAction( udt_send_2_166 );

	// Init arrays for variables
	BaseStateVariableClass* ROVars[] = {
		&bit0,
		&bit1,
		&bit2,
		&bit3,
		&bit4,
		&bit5,
		&bit6,
		&bit7,
		&bit8,
		&bit9,
		&bit10,
		&bit11,
		&bit12,
		&bit13,
		&bit14,
		&bit15,
		&bit16,
		&bit17,
		&bit18,
		&bit19,
		&bit20,
		&bit21,
		&bit22,
		&bit23,
		&bit24,
		&bit25,
		&bit26,
		&bit27,
		&bit28,
		&bit29,
		&bit30,
		&bit31,
		&bit32,
		&bit33,
		&bit34,
		&bit35,
		&bit36,
		&bit37,
		&bit38,
		&bit39,
		&bit40,
		&bit41,
		&bit42,
		&bit43,
		&bit44,
		&bit45,
		&bit46,
		&bit47,
		&bit48,
		&bit49,
		&bit50,
		&bit51,
		&bit52,
		&bit53,
		&bit54,
		&bit55,
		&bit56,
		&bit57,
		&bit58,
		&bit59,
		&bit60,
		&bit61,
		&bit62,
		&bit63,
		&bit64,
		&bit65,
		&bit66,
		&bit67,
		&bit68,
		&bit69,
		&bit70,
		&bit71,
		&bit72,
		&bit73,
		&bit74,
		&bit75,
		&bit76,
		packet,
		pctc1,
		pctl1,
		pcto1,
		pcts1,
		0
	};
	BaseStateVariableClass* SVars[] = { 
		packet,
		pctc1,
		pctl1,
		pcto1,
		pcts1,
		0
	};
	// Write Init arrays for actions
	BaseActionClass* InitialActionList[] = {
			break_34,
			break_57,
			break_108,
			break_131,
		rdt_rcv_1Sync0,
		rdt_rcv_1Sync1,
		rdt_rcv_1Sync2,
		rdt_rcv_1Sync3,
		rdt_rcv_1Sync4,
		rdt_rcv_1Sync5,
		rdt_rcv_2Sync6,
		rdt_rcv_2Sync7,
		rdt_rcv_2Sync8,
		rdt_rcv_2Sync9,
		rdt_rcv_2Sync10,
		rdt_rcv_2Sync11,
			tau_2,
			tau_160,
			tau_164,
			tau_170,
			tau_174,
			compute_checksum_26,
			compute_checksum_35,
			compute_checksum_67,
			deliver_data_25,
			deliver_data_66,
			extract_24,
			extract_65,
			make_pkt_27,
			make_pkt_36,
			make_pkt_68,
			rdt_send_33,
			start_timer_39,
			start_timer_51,
			start_timer_77,
			tau_9,
			tau_19,
			tau_31,
			tau_48,
			tau_55,
			tau_60,
			tau_74,
			compute_checksum_100,
			compute_checksum_109,
			compute_checksum_141,
			deliver_data_99,
			deliver_data_140,
			extract_98,
			extract_139,
			make_pkt_101,
			make_pkt_110,
			make_pkt_142,
			rdt_send_107,
			start_timer_113,
			start_timer_125,
			start_timer_151,
			tau_83,
			tau_93,
			tau_105,
			tau_122,
			tau_129,
			tau_134,
			tau_148,
		udt_send_1Sync12,
		udt_send_1Sync13,
		udt_send_1Sync14,
		udt_send_1Sync15,
		udt_send_1Sync16,
		udt_send_1Sync17,
		udt_send_1Sync18,
		udt_send_2Sync19,
		udt_send_2Sync20,
		udt_send_2Sync21,
		udt_send_2Sync22,
		udt_send_2Sync23,
		udt_send_2Sync24,
		udt_send_2Sync25,
		0
	};
	BaseGroupClass* InitialGroupList[] = {
		break_34,
		break_57,
		break_108,
		break_131,
		rdt_rcv_1Sync0,
		rdt_rcv_1Sync1,
		rdt_rcv_1Sync2,
		rdt_rcv_1Sync3,
		rdt_rcv_1Sync4,
		rdt_rcv_1Sync5,
		rdt_rcv_2Sync6,
		rdt_rcv_2Sync7,
		rdt_rcv_2Sync8,
		rdt_rcv_2Sync9,
		rdt_rcv_2Sync10,
		rdt_rcv_2Sync11,
		tau_2,
		tau_160,
		tau_164,
		tau_170,
		tau_174,
		compute_checksum_26,
		compute_checksum_35,
		compute_checksum_67,
		deliver_data_25,
		deliver_data_66,
		extract_24,
		extract_65,
		make_pkt_27,
		make_pkt_36,
		make_pkt_68,
		rdt_send_33,
		start_timer_39,
		start_timer_51,
		start_timer_77,
		tau_9,
		tau_19,
		tau_31,
		tau_48,
		tau_55,
		tau_60,
		tau_74,
		compute_checksum_100,
		compute_checksum_109,
		compute_checksum_141,
		deliver_data_99,
		deliver_data_140,
		extract_98,
		extract_139,
		make_pkt_101,
		make_pkt_110,
		make_pkt_142,
		rdt_send_107,
		start_timer_113,
		start_timer_125,
		start_timer_151,
		tau_83,
		tau_93,
		tau_105,
		tau_122,
		tau_129,
		tau_134,
		tau_148,
		udt_send_1Sync12,
		udt_send_1Sync13,
		udt_send_1Sync14,
		udt_send_1Sync15,
		udt_send_1Sync16,
		udt_send_1Sync17,
		udt_send_1Sync18,
		udt_send_2Sync19,
		udt_send_2Sync20,
		udt_send_2Sync21,
		udt_send_2Sync22,
		udt_send_2Sync23,
		udt_send_2Sync24,
		udt_send_2Sync25,
		0
	};

	initializeModelNow("rdt4_0",
		(sizeof(SVars) / sizeof(BaseStateVariableClass*))-1, SVars,
		(sizeof(ROVars) / sizeof(BaseStateVariableClass*))-1, ROVars,
		(sizeof(InitialActionList) / sizeof(BaseActionClass*))-1, InitialActionList,
		(sizeof(InitialGroupList) / sizeof(BaseGroupClass*))-1, InitialGroupList);

	// Set the initial state
	con[1]->kick_passers();
	const ModestConstruct::mask_type* mask = con[1]->getEnableMask();
	for(unsigned int i = 0; i < 3; i++)
		enabling_bits[i] = mask[i];
} // end constructor
#endif // MODEST_INCLUDE_MODEL
