#include "reward_rdt1_0PVNodes.h"

reward_rdt1_0PV0Worker::reward_rdt1_0PV0Worker()
{
  NumModels = 1;
  TheModelPtr = new (BaseModelClass**)[NumModels];
  TheModelPtr[0] = (BaseModelClass**)(&rdt1_0);
}

reward_rdt1_0PV0Worker::~reward_rdt1_0PV0Worker() {
  delete [] TheModelPtr;
}

double reward_rdt1_0PV0Worker::Reward_Function(void)
{

return rdt1_0->loss->getValue();

return (0);



}

reward_rdt1_0PV0::reward_rdt1_0PV0()
{
  TheModelPtr = (BaseModelClass**)(&Therdt1_0EXT);

  Initialize("loss",0.0,0.0,0,1 , 1,0);
  AddVariableDependency("loss","rdt1_0");
}

reward_rdt1_0PV0::~reward_rdt1_0PV0() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void reward_rdt1_0PV0::CreateWorkerList(void)
{
  for(int i = 0; i < NumberOfWorkers; i++)
    WorkerList[i] = new reward_rdt1_0PV0Worker;
}
reward_rdt1_0PV1Impulse0::reward_rdt1_0PV1Impulse0()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new (BaseModelClass**)[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&rdt1_0);
}

reward_rdt1_0PV1Impulse0::~reward_rdt1_0PV1Impulse0() {
  delete [] TheModelPtr;
}

double reward_rdt1_0PV1Impulse0::Impulse_Function(double FiringTime)
{
if (rdt1_0->udt_sendSync1)
{
   if (rdt1_0->rdt_rcvSync0)
      return 1;
   return 0;
}

return(0);
}

ImpulseNodeClass** reward_rdt1_0PV1Impulse0::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerList = new (ImpulseNodeClass*)[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new reward_rdt1_0PV1Impulse0[1];
  }

  return ImpulseWorkerList;
}

reward_rdt1_0PV1Impulse1::reward_rdt1_0PV1Impulse1()
{
  NumberOfModelDependencies = 1;
  TheModelPtr = new (BaseModelClass**)[NumberOfModelDependencies];
  TheModelPtr[0] = (BaseModelClass**)(&rdt1_0);
}

reward_rdt1_0PV1Impulse1::~reward_rdt1_0PV1Impulse1() {
  delete [] TheModelPtr;
}

double reward_rdt1_0PV1Impulse1::Impulse_Function(double FiringTime)
{
int val;
if (rdt1_0->udt_sendSync1)
{
   val=-2;
}
if (rdt1_0->rdt_rcvSync0)
{
   val+=1;
}
return val;



return(0);
}

ImpulseNodeClass** reward_rdt1_0PV1Impulse1::CreateImpulseWorkerList(int NumberOfWorkers) {
  ImpulseWorkerList = new (ImpulseNodeClass*)[NumberOfWorkers];

  for (int ImpulseWorkerCounter = 0; ImpulseWorkerCounter < NumberOfWorkers; ImpulseWorkerCounter++)
  {
    ImpulseWorkerList[ImpulseWorkerCounter] = new reward_rdt1_0PV1Impulse1[1];
  }

  return ImpulseWorkerList;
}

reward_rdt1_0PV1::reward_rdt1_0PV1()
{
  TheModelPtr = (BaseModelClass**)(&Therdt1_0EXT);

  Initialize("test",0.0,0.0,2,0 , 0,1);
  AddImpulse("rdt_rcvSync0","rdt1_0",&Impulse0);
  AddImpulse("udt_sendSync1","rdt1_0",&Impulse1);
}

reward_rdt1_0PV1::~reward_rdt1_0PV1() {
  for(int i = 0; i < NumberOfWorkers; i++) {
    delete[] WorkerList[i]->Name;
    delete WorkerList[i];
  }
}

void reward_rdt1_0PV1::CreateWorkerList(void)
{
}
