#ifndef _REWARD_RDT1_0_PVS_
#define _REWARD_RDT1_0_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Atomic/rdt1_0/rdt1_0EXT.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"
#include "Cpp/Performance_Variables/InstantOfTimeImpulse.hpp"


class reward_rdt1_0PV0Worker:public InstantOfTime
{
 public:
  rdt1_0EXT *rdt1_0;
  
  reward_rdt1_0PV0Worker();
  ~reward_rdt1_0PV0Worker();
  double Reward_Function();
};

class reward_rdt1_0PV0:public PerformanceVariableNode
{
 public:
  rdt1_0EXT *Therdt1_0EXT;

  reward_rdt1_0PV0Worker *reward_rdt1_0PV0WorkerList;

  reward_rdt1_0PV0();
  ~reward_rdt1_0PV0();
  void CreateWorkerList(void);
};


class reward_rdt1_0PV1Impulse0:public InstantOfTimeImpulse
{
 public:
  rdt1_0EXT *rdt1_0;

  reward_rdt1_0PV1Impulse0();
  ~reward_rdt1_0PV1Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
};


class reward_rdt1_0PV1Impulse1:public InstantOfTimeImpulse
{
 public:
  rdt1_0EXT *rdt1_0;

  reward_rdt1_0PV1Impulse1();
  ~reward_rdt1_0PV1Impulse1();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
};

class reward_rdt1_0PV1:public PerformanceVariableNode
{
 public:
  rdt1_0EXT *Therdt1_0EXT;

  reward_rdt1_0PV1Impulse0 Impulse0;
  reward_rdt1_0PV1Impulse1 Impulse1;

  reward_rdt1_0PV1();
  ~reward_rdt1_0PV1();
  void CreateWorkerList(void);
};

#endif
