#ifndef _REWARD_RDT2_0_PVS_
#define _REWARD_RDT2_0_PVS_
#include <math.h>
#include "Cpp/Performance_Variables/PerformanceVariableNode.hpp"
#include "Atomic/rdt2_0/rdt2_0EXT.h"
#include "Cpp/Performance_Variables/InstantOfTime.hpp"
#include "Cpp/Performance_Variables/InstantOfTimeImpulse.hpp"


class reward_rdt2_0PV0Worker:public InstantOfTime
{
 public:
  rdt2_0EXT *rdt2_0;
  
  reward_rdt2_0PV0Worker();
  ~reward_rdt2_0PV0Worker();
  double Reward_Function();
};

class reward_rdt2_0PV0:public PerformanceVariableNode
{
 public:
  rdt2_0EXT *Therdt2_0EXT;

  reward_rdt2_0PV0Worker *reward_rdt2_0PV0WorkerList;

  reward_rdt2_0PV0();
  ~reward_rdt2_0PV0();
  void CreateWorkerList(void);
};


class reward_rdt2_0PV1Impulse0:public InstantOfTimeImpulse
{
 public:
  rdt2_0EXT *rdt2_0;

  reward_rdt2_0PV1Impulse0();
  ~reward_rdt2_0PV1Impulse0();
  double Impulse_Function(double);
  ImpulseNodeClass** CreateImpulseWorkerList(int);
 private:
  ImpulseNodeClass** ImpulseWorkerList;
};

class reward_rdt2_0PV1:public PerformanceVariableNode
{
 public:
  rdt2_0EXT *Therdt2_0EXT;

  reward_rdt2_0PV1Impulse0 Impulse0;

  reward_rdt2_0PV1();
  ~reward_rdt2_0PV1();
  void CreateWorkerList(void);
};

#endif
