
#include "Study/study_rdt1_0/study_rdt1_0RangeStudy.h"

//******************************************************
//Global Variables
//******************************************************

//********************************************************
//study_rdt1_0RangeStudy Constructor
//********************************************************
study_rdt1_0RangeStudy::study_rdt1_0RangeStudy() {

  // define arrays of global variable names and types
  NumGVs = 0;
  NumExps = 1;

  GVNames = new char*[NumGVs];
  GVTypes = new char*[NumGVs];

  // create the arrays to store the values of each gv

  // call methods to assign values to each gv
  SetDefaultMobiusRoot(MOBIUSROOT);
}


//******************************************************
//study_rdt1_0RangeStudy Destructor
//******************************************************
study_rdt1_0RangeStudy::~study_rdt1_0RangeStudy() {
  delete ThePVModel;
}



//******************************************************
//print values of gv (for debugging)
//******************************************************
void study_rdt1_0RangeStudy::PrintGlobalValues(int expNum) {
  if (NumGVs == 0) {
    cout<<"There are no global variables."<<endl;
    return;
  }

  SetGVs(expNum);

  cout<<"The Global Variable values for experiment "<<
    GetExpName(expNum)<<" are:"<<endl;
}


//******************************************************
//retrieve the value of a global variable
//******************************************************
void *study_rdt1_0RangeStudy::GetGVValue(char *TheGVName) {
  
    cerr<<"!! study_rdt1_0RangeStudy::GetGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
  return NULL;
}


//******************************************************
//override the value of a global variable
//******************************************************
void study_rdt1_0RangeStudy::OverrideGVValue(char *TheGVName,void *TheGVValue) {
  
    cerr<<"!! study_rdt1_0RangeStudy::OverrideGVValue: Global Variable "<<TheGVName<<" does not exist."<<endl;
}


//******************************************************
//set the value of all global variables to the given exp
//******************************************************
void study_rdt1_0RangeStudy::SetGVs(int expNum) {
}


//******************************************************
//static class method called by solvers to create study 
//(and thus create all of the model)
//******************************************************
BaseStudyClass* GlobalStudyPtr = NULL;
BaseStudyClass * GenerateStudy() {
  if (GlobalStudyPtr == NULL)
    GlobalStudyPtr = new study_rdt1_0RangeStudy();
  return GlobalStudyPtr;
}

void DestructStudy() {
  delete GlobalStudyPtr;
  GlobalStudyPtr = NULL;
}
//******************************************************
//get and create the PVModel
//******************************************************
PVModel* study_rdt1_0RangeStudy::GetPVModel() {
  // create the PV model
  ThePVModel=new reward_rdt1_0PVModel();
  return ThePVModel;
}


